// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rai_interfaces:action/Task.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__ACTION__DETAIL__TASK__BUILDER_HPP_
#define RAI_INTERFACES__ACTION__DETAIL__TASK__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "rai_interfaces/action/detail/task__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_Goal_priority
{
public:
  explicit Init_Task_Goal_priority(::rai_interfaces::action::Task_Goal & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::Task_Goal priority(::rai_interfaces::action::Task_Goal::_priority_type arg)
  {
    msg_.priority = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_Goal msg_;
};

class Init_Task_Goal_description
{
public:
  explicit Init_Task_Goal_description(::rai_interfaces::action::Task_Goal & msg)
  : msg_(msg)
  {}
  Init_Task_Goal_priority description(::rai_interfaces::action::Task_Goal::_description_type arg)
  {
    msg_.description = std::move(arg);
    return Init_Task_Goal_priority(msg_);
  }

private:
  ::rai_interfaces::action::Task_Goal msg_;
};

class Init_Task_Goal_task
{
public:
  Init_Task_Goal_task()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Task_Goal_description task(::rai_interfaces::action::Task_Goal::_task_type arg)
  {
    msg_.task = std::move(arg);
    return Init_Task_Goal_description(msg_);
  }

private:
  ::rai_interfaces::action::Task_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_Goal>()
{
  return rai_interfaces::action::builder::Init_Task_Goal_task();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_Result_report
{
public:
  explicit Init_Task_Result_report(::rai_interfaces::action::Task_Result & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::Task_Result report(::rai_interfaces::action::Task_Result::_report_type arg)
  {
    msg_.report = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_Result msg_;
};

class Init_Task_Result_success
{
public:
  Init_Task_Result_success()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Task_Result_report success(::rai_interfaces::action::Task_Result::_success_type arg)
  {
    msg_.success = std::move(arg);
    return Init_Task_Result_report(msg_);
  }

private:
  ::rai_interfaces::action::Task_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_Result>()
{
  return rai_interfaces::action::builder::Init_Task_Result_success();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_Feedback_current_status
{
public:
  Init_Task_Feedback_current_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::rai_interfaces::action::Task_Feedback current_status(::rai_interfaces::action::Task_Feedback::_current_status_type arg)
  {
    msg_.current_status = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_Feedback>()
{
  return rai_interfaces::action::builder::Init_Task_Feedback_current_status();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_SendGoal_Request_goal
{
public:
  explicit Init_Task_SendGoal_Request_goal(::rai_interfaces::action::Task_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::Task_SendGoal_Request goal(::rai_interfaces::action::Task_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_SendGoal_Request msg_;
};

class Init_Task_SendGoal_Request_goal_id
{
public:
  Init_Task_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Task_SendGoal_Request_goal goal_id(::rai_interfaces::action::Task_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_Task_SendGoal_Request_goal(msg_);
  }

private:
  ::rai_interfaces::action::Task_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_SendGoal_Request>()
{
  return rai_interfaces::action::builder::Init_Task_SendGoal_Request_goal_id();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_SendGoal_Response_stamp
{
public:
  explicit Init_Task_SendGoal_Response_stamp(::rai_interfaces::action::Task_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::Task_SendGoal_Response stamp(::rai_interfaces::action::Task_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_SendGoal_Response msg_;
};

class Init_Task_SendGoal_Response_accepted
{
public:
  Init_Task_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Task_SendGoal_Response_stamp accepted(::rai_interfaces::action::Task_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_Task_SendGoal_Response_stamp(msg_);
  }

private:
  ::rai_interfaces::action::Task_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_SendGoal_Response>()
{
  return rai_interfaces::action::builder::Init_Task_SendGoal_Response_accepted();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_GetResult_Request_goal_id
{
public:
  Init_Task_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::rai_interfaces::action::Task_GetResult_Request goal_id(::rai_interfaces::action::Task_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_GetResult_Request>()
{
  return rai_interfaces::action::builder::Init_Task_GetResult_Request_goal_id();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_GetResult_Response_result
{
public:
  explicit Init_Task_GetResult_Response_result(::rai_interfaces::action::Task_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::Task_GetResult_Response result(::rai_interfaces::action::Task_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_GetResult_Response msg_;
};

class Init_Task_GetResult_Response_status
{
public:
  Init_Task_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Task_GetResult_Response_result status(::rai_interfaces::action::Task_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_Task_GetResult_Response_result(msg_);
  }

private:
  ::rai_interfaces::action::Task_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_GetResult_Response>()
{
  return rai_interfaces::action::builder::Init_Task_GetResult_Response_status();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_Task_FeedbackMessage_feedback
{
public:
  explicit Init_Task_FeedbackMessage_feedback(::rai_interfaces::action::Task_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::Task_FeedbackMessage feedback(::rai_interfaces::action::Task_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::Task_FeedbackMessage msg_;
};

class Init_Task_FeedbackMessage_goal_id
{
public:
  Init_Task_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Task_FeedbackMessage_feedback goal_id(::rai_interfaces::action::Task_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_Task_FeedbackMessage_feedback(msg_);
  }

private:
  ::rai_interfaces::action::Task_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::Task_FeedbackMessage>()
{
  return rai_interfaces::action::builder::Init_Task_FeedbackMessage_goal_id();
}

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__ACTION__DETAIL__TASK__BUILDER_HPP_
