// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rai_interfaces:action/Task.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__ACTION__DETAIL__TASK__STRUCT_H_
#define RAI_INTERFACES__ACTION__DETAIL__TASK__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'task'
// Member 'description'
// Member 'priority'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_Goal
{
  rosidl_runtime_c__String task;
  rosidl_runtime_c__String description;
  rosidl_runtime_c__String priority;
} rai_interfaces__action__Task_Goal;

// Struct for a sequence of rai_interfaces__action__Task_Goal.
typedef struct rai_interfaces__action__Task_Goal__Sequence
{
  rai_interfaces__action__Task_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'report'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_Result
{
  bool success;
  rosidl_runtime_c__String report;
} rai_interfaces__action__Task_Result;

// Struct for a sequence of rai_interfaces__action__Task_Result.
typedef struct rai_interfaces__action__Task_Result__Sequence
{
  rai_interfaces__action__Task_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'current_status'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_Feedback
{
  rosidl_runtime_c__String current_status;
} rai_interfaces__action__Task_Feedback;

// Struct for a sequence of rai_interfaces__action__Task_Feedback.
typedef struct rai_interfaces__action__Task_Feedback__Sequence
{
  rai_interfaces__action__Task_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "rai_interfaces/action/detail/task__struct.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  rai_interfaces__action__Task_Goal goal;
} rai_interfaces__action__Task_SendGoal_Request;

// Struct for a sequence of rai_interfaces__action__Task_SendGoal_Request.
typedef struct rai_interfaces__action__Task_SendGoal_Request__Sequence
{
  rai_interfaces__action__Task_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} rai_interfaces__action__Task_SendGoal_Response;

// Struct for a sequence of rai_interfaces__action__Task_SendGoal_Response.
typedef struct rai_interfaces__action__Task_SendGoal_Response__Sequence
{
  rai_interfaces__action__Task_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} rai_interfaces__action__Task_GetResult_Request;

// Struct for a sequence of rai_interfaces__action__Task_GetResult_Request.
typedef struct rai_interfaces__action__Task_GetResult_Request__Sequence
{
  rai_interfaces__action__Task_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "rai_interfaces/action/detail/task__struct.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_GetResult_Response
{
  int8_t status;
  rai_interfaces__action__Task_Result result;
} rai_interfaces__action__Task_GetResult_Response;

// Struct for a sequence of rai_interfaces__action__Task_GetResult_Response.
typedef struct rai_interfaces__action__Task_GetResult_Response__Sequence
{
  rai_interfaces__action__Task_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "rai_interfaces/action/detail/task__struct.h"

/// Struct defined in action/Task in the package rai_interfaces.
typedef struct rai_interfaces__action__Task_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  rai_interfaces__action__Task_Feedback feedback;
} rai_interfaces__action__Task_FeedbackMessage;

// Struct for a sequence of rai_interfaces__action__Task_FeedbackMessage.
typedef struct rai_interfaces__action__Task_FeedbackMessage__Sequence
{
  rai_interfaces__action__Task_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__action__Task_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__ACTION__DETAIL__TASK__STRUCT_H_
