// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:action/Task.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__ACTION__DETAIL__TASK__TRAITS_HPP_
#define RAI_INTERFACES__ACTION__DETAIL__TASK__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/action/detail/task__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: task
  {
    out << "task: ";
    rosidl_generator_traits::value_to_yaml(msg.task, out);
    out << ", ";
  }

  // member: description
  {
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << ", ";
  }

  // member: priority
  {
    out << "priority: ";
    rosidl_generator_traits::value_to_yaml(msg.priority, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: task
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "task: ";
    rosidl_generator_traits::value_to_yaml(msg.task, out);
    out << "\n";
  }

  // member: description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << "\n";
  }

  // member: priority
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "priority: ";
    rosidl_generator_traits::value_to_yaml(msg.priority, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_Goal & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_Goal>()
{
  return "rai_interfaces::action::Task_Goal";
}

template<>
inline const char * name<rai_interfaces::action::Task_Goal>()
{
  return "rai_interfaces/action/Task_Goal";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::action::Task_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: report
  {
    out << "report: ";
    rosidl_generator_traits::value_to_yaml(msg.report, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: report
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "report: ";
    rosidl_generator_traits::value_to_yaml(msg.report, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_Result & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_Result>()
{
  return "rai_interfaces::action::Task_Result";
}

template<>
inline const char * name<rai_interfaces::action::Task_Result>()
{
  return "rai_interfaces/action/Task_Result";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::action::Task_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: current_status
  {
    out << "current_status: ";
    rosidl_generator_traits::value_to_yaml(msg.current_status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: current_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current_status: ";
    rosidl_generator_traits::value_to_yaml(msg.current_status, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_Feedback & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_Feedback>()
{
  return "rai_interfaces::action::Task_Feedback";
}

template<>
inline const char * name<rai_interfaces::action::Task_Feedback>()
{
  return "rai_interfaces/action/Task_Feedback";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::action::Task_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "rai_interfaces/action/detail/task__traits.hpp"

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_SendGoal_Request & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_SendGoal_Request>()
{
  return "rai_interfaces::action::Task_SendGoal_Request";
}

template<>
inline const char * name<rai_interfaces::action::Task_SendGoal_Request>()
{
  return "rai_interfaces/action/Task_SendGoal_Request";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<rai_interfaces::action::Task_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<rai_interfaces::action::Task_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<rai_interfaces::action::Task_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_SendGoal_Response & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_SendGoal_Response>()
{
  return "rai_interfaces::action::Task_SendGoal_Response";
}

template<>
inline const char * name<rai_interfaces::action::Task_SendGoal_Response>()
{
  return "rai_interfaces/action/Task_SendGoal_Response";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<rai_interfaces::action::Task_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::action::Task_SendGoal>()
{
  return "rai_interfaces::action::Task_SendGoal";
}

template<>
inline const char * name<rai_interfaces::action::Task_SendGoal>()
{
  return "rai_interfaces/action/Task_SendGoal";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::action::Task_SendGoal_Request>::value &&
    has_fixed_size<rai_interfaces::action::Task_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::action::Task_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::action::Task_SendGoal_Request>::value &&
    has_bounded_size<rai_interfaces::action::Task_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::action::Task_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::action::Task_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::action::Task_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_GetResult_Request & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_GetResult_Request>()
{
  return "rai_interfaces::action::Task_GetResult_Request";
}

template<>
inline const char * name<rai_interfaces::action::Task_GetResult_Request>()
{
  return "rai_interfaces/action/Task_GetResult_Request";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<rai_interfaces::action::Task_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "rai_interfaces/action/detail/task__traits.hpp"

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_GetResult_Response & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_GetResult_Response>()
{
  return "rai_interfaces::action::Task_GetResult_Response";
}

template<>
inline const char * name<rai_interfaces::action::Task_GetResult_Response>()
{
  return "rai_interfaces/action/Task_GetResult_Response";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<rai_interfaces::action::Task_Result>::value> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<rai_interfaces::action::Task_Result>::value> {};

template<>
struct is_message<rai_interfaces::action::Task_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::action::Task_GetResult>()
{
  return "rai_interfaces::action::Task_GetResult";
}

template<>
inline const char * name<rai_interfaces::action::Task_GetResult>()
{
  return "rai_interfaces/action/Task_GetResult";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::action::Task_GetResult_Request>::value &&
    has_fixed_size<rai_interfaces::action::Task_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::action::Task_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::action::Task_GetResult_Request>::value &&
    has_bounded_size<rai_interfaces::action::Task_GetResult_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::action::Task_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::action::Task_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::action::Task_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "rai_interfaces/action/detail/task__traits.hpp"

namespace rai_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Task_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Task_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Task_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::action::Task_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::action::Task_FeedbackMessage & msg)
{
  return rai_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::action::Task_FeedbackMessage>()
{
  return "rai_interfaces::action::Task_FeedbackMessage";
}

template<>
inline const char * name<rai_interfaces::action::Task_FeedbackMessage>()
{
  return "rai_interfaces/action/Task_FeedbackMessage";
}

template<>
struct has_fixed_size<rai_interfaces::action::Task_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<rai_interfaces::action::Task_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<rai_interfaces::action::Task_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<rai_interfaces::action::Task_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<rai_interfaces::action::Task_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<rai_interfaces::action::Task>
  : std::true_type
{
};

template<>
struct is_action_goal<rai_interfaces::action::Task_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<rai_interfaces::action::Task_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<rai_interfaces::action::Task_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // RAI_INTERFACES__ACTION__DETAIL__TASK__TRAITS_HPP_
