// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:msg/AudioMessage.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/msg/detail/audio_message__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `audio`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
rai_interfaces__msg__AudioMessage__init(rai_interfaces__msg__AudioMessage * msg)
{
  if (!msg) {
    return false;
  }
  // audio
  if (!rosidl_runtime_c__int16__Sequence__init(&msg->audio, 0)) {
    rai_interfaces__msg__AudioMessage__fini(msg);
    return false;
  }
  // sample_rate
  // channels
  return true;
}

void
rai_interfaces__msg__AudioMessage__fini(rai_interfaces__msg__AudioMessage * msg)
{
  if (!msg) {
    return;
  }
  // audio
  rosidl_runtime_c__int16__Sequence__fini(&msg->audio);
  // sample_rate
  // channels
}

bool
rai_interfaces__msg__AudioMessage__are_equal(const rai_interfaces__msg__AudioMessage * lhs, const rai_interfaces__msg__AudioMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // audio
  if (!rosidl_runtime_c__int16__Sequence__are_equal(
      &(lhs->audio), &(rhs->audio)))
  {
    return false;
  }
  // sample_rate
  if (lhs->sample_rate != rhs->sample_rate) {
    return false;
  }
  // channels
  if (lhs->channels != rhs->channels) {
    return false;
  }
  return true;
}

bool
rai_interfaces__msg__AudioMessage__copy(
  const rai_interfaces__msg__AudioMessage * input,
  rai_interfaces__msg__AudioMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // audio
  if (!rosidl_runtime_c__int16__Sequence__copy(
      &(input->audio), &(output->audio)))
  {
    return false;
  }
  // sample_rate
  output->sample_rate = input->sample_rate;
  // channels
  output->channels = input->channels;
  return true;
}

rai_interfaces__msg__AudioMessage *
rai_interfaces__msg__AudioMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__AudioMessage * msg = (rai_interfaces__msg__AudioMessage *)allocator.allocate(sizeof(rai_interfaces__msg__AudioMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__msg__AudioMessage));
  bool success = rai_interfaces__msg__AudioMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__msg__AudioMessage__destroy(rai_interfaces__msg__AudioMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__msg__AudioMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__msg__AudioMessage__Sequence__init(rai_interfaces__msg__AudioMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__AudioMessage * data = NULL;

  if (size) {
    data = (rai_interfaces__msg__AudioMessage *)allocator.zero_allocate(size, sizeof(rai_interfaces__msg__AudioMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__msg__AudioMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__msg__AudioMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__msg__AudioMessage__Sequence__fini(rai_interfaces__msg__AudioMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__msg__AudioMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__msg__AudioMessage__Sequence *
rai_interfaces__msg__AudioMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__AudioMessage__Sequence * array = (rai_interfaces__msg__AudioMessage__Sequence *)allocator.allocate(sizeof(rai_interfaces__msg__AudioMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__msg__AudioMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__msg__AudioMessage__Sequence__destroy(rai_interfaces__msg__AudioMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__msg__AudioMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__msg__AudioMessage__Sequence__are_equal(const rai_interfaces__msg__AudioMessage__Sequence * lhs, const rai_interfaces__msg__AudioMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__msg__AudioMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__msg__AudioMessage__Sequence__copy(
  const rai_interfaces__msg__AudioMessage__Sequence * input,
  rai_interfaces__msg__AudioMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__msg__AudioMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__msg__AudioMessage * data =
      (rai_interfaces__msg__AudioMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__msg__AudioMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__msg__AudioMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__msg__AudioMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
