// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rai_interfaces:msg/AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__FUNCTIONS_H_
#define RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rai_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "rai_interfaces/msg/detail/audio_message__struct.h"

/// Initialize msg/AudioMessage message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__msg__AudioMessage
 * )) before or use
 * rai_interfaces__msg__AudioMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__msg__AudioMessage__init(rai_interfaces__msg__AudioMessage * msg);

/// Finalize msg/AudioMessage message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__msg__AudioMessage__fini(rai_interfaces__msg__AudioMessage * msg);

/// Create msg/AudioMessage message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__msg__AudioMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__msg__AudioMessage *
rai_interfaces__msg__AudioMessage__create();

/// Destroy msg/AudioMessage message.
/**
 * It calls
 * rai_interfaces__msg__AudioMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__msg__AudioMessage__destroy(rai_interfaces__msg__AudioMessage * msg);

/// Check for msg/AudioMessage message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__msg__AudioMessage__are_equal(const rai_interfaces__msg__AudioMessage * lhs, const rai_interfaces__msg__AudioMessage * rhs);

/// Copy a msg/AudioMessage message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__msg__AudioMessage__copy(
  const rai_interfaces__msg__AudioMessage * input,
  rai_interfaces__msg__AudioMessage * output);

/// Initialize array of msg/AudioMessage messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__msg__AudioMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__msg__AudioMessage__Sequence__init(rai_interfaces__msg__AudioMessage__Sequence * array, size_t size);

/// Finalize array of msg/AudioMessage messages.
/**
 * It calls
 * rai_interfaces__msg__AudioMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__msg__AudioMessage__Sequence__fini(rai_interfaces__msg__AudioMessage__Sequence * array);

/// Create array of msg/AudioMessage messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__msg__AudioMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__msg__AudioMessage__Sequence *
rai_interfaces__msg__AudioMessage__Sequence__create(size_t size);

/// Destroy array of msg/AudioMessage messages.
/**
 * It calls
 * rai_interfaces__msg__AudioMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__msg__AudioMessage__Sequence__destroy(rai_interfaces__msg__AudioMessage__Sequence * array);

/// Check for msg/AudioMessage message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__msg__AudioMessage__Sequence__are_equal(const rai_interfaces__msg__AudioMessage__Sequence * lhs, const rai_interfaces__msg__AudioMessage__Sequence * rhs);

/// Copy an array of msg/AudioMessage messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__msg__AudioMessage__Sequence__copy(
  const rai_interfaces__msg__AudioMessage__Sequence * input,
  rai_interfaces__msg__AudioMessage__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__FUNCTIONS_H_
