// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:msg/AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__STRUCT_HPP_
#define RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__msg__AudioMessage __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__msg__AudioMessage __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AudioMessage_
{
  using Type = AudioMessage_<ContainerAllocator>;

  explicit AudioMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sample_rate = 0;
      this->channels = 0;
    }
  }

  explicit AudioMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sample_rate = 0;
      this->channels = 0;
    }
  }

  // field types and members
  using _audio_type =
    std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>>;
  _audio_type audio;
  using _sample_rate_type =
    uint16_t;
  _sample_rate_type sample_rate;
  using _channels_type =
    uint16_t;
  _channels_type channels;

  // setters for named parameter idiom
  Type & set__audio(
    const std::vector<int16_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int16_t>> & _arg)
  {
    this->audio = _arg;
    return *this;
  }
  Type & set__sample_rate(
    const uint16_t & _arg)
  {
    this->sample_rate = _arg;
    return *this;
  }
  Type & set__channels(
    const uint16_t & _arg)
  {
    this->channels = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::msg::AudioMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::msg::AudioMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::msg::AudioMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::msg::AudioMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__msg__AudioMessage
    std::shared_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__msg__AudioMessage
    std::shared_ptr<rai_interfaces::msg::AudioMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AudioMessage_ & other) const
  {
    if (this->audio != other.audio) {
      return false;
    }
    if (this->sample_rate != other.sample_rate) {
      return false;
    }
    if (this->channels != other.channels) {
      return false;
    }
    return true;
  }
  bool operator!=(const AudioMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AudioMessage_

// alias to use template instance with default allocator
using AudioMessage =
  rai_interfaces::msg::AudioMessage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__STRUCT_HPP_
