// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:msg/AudioMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__TRAITS_HPP_
#define RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/msg/detail/audio_message__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rai_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const AudioMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: audio
  {
    if (msg.audio.size() == 0) {
      out << "audio: []";
    } else {
      out << "audio: [";
      size_t pending_items = msg.audio.size();
      for (auto item : msg.audio) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: sample_rate
  {
    out << "sample_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.sample_rate, out);
    out << ", ";
  }

  // member: channels
  {
    out << "channels: ";
    rosidl_generator_traits::value_to_yaml(msg.channels, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AudioMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: audio
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.audio.size() == 0) {
      out << "audio: []\n";
    } else {
      out << "audio:\n";
      for (auto item : msg.audio) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: sample_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sample_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.sample_rate, out);
    out << "\n";
  }

  // member: channels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "channels: ";
    rosidl_generator_traits::value_to_yaml(msg.channels, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AudioMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::msg::AudioMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::msg::AudioMessage & msg)
{
  return rai_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::msg::AudioMessage>()
{
  return "rai_interfaces::msg::AudioMessage";
}

template<>
inline const char * name<rai_interfaces::msg::AudioMessage>()
{
  return "rai_interfaces/msg/AudioMessage";
}

template<>
struct has_fixed_size<rai_interfaces::msg::AudioMessage>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::msg::AudioMessage>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::msg::AudioMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__MSG__DETAIL__AUDIO_MESSAGE__TRAITS_HPP_
