// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rai_interfaces:msg/HRIMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__BUILDER_HPP_
#define RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "rai_interfaces/msg/detail/hri_message__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace rai_interfaces
{

namespace msg
{

namespace builder
{

class Init_HRIMessage_seq_end
{
public:
  explicit Init_HRIMessage_seq_end(::rai_interfaces::msg::HRIMessage & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::msg::HRIMessage seq_end(::rai_interfaces::msg::HRIMessage::_seq_end_type arg)
  {
    msg_.seq_end = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

class Init_HRIMessage_seq_no
{
public:
  explicit Init_HRIMessage_seq_no(::rai_interfaces::msg::HRIMessage & msg)
  : msg_(msg)
  {}
  Init_HRIMessage_seq_end seq_no(::rai_interfaces::msg::HRIMessage::_seq_no_type arg)
  {
    msg_.seq_no = std::move(arg);
    return Init_HRIMessage_seq_end(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

class Init_HRIMessage_communication_id
{
public:
  explicit Init_HRIMessage_communication_id(::rai_interfaces::msg::HRIMessage & msg)
  : msg_(msg)
  {}
  Init_HRIMessage_seq_no communication_id(::rai_interfaces::msg::HRIMessage::_communication_id_type arg)
  {
    msg_.communication_id = std::move(arg);
    return Init_HRIMessage_seq_no(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

class Init_HRIMessage_audios
{
public:
  explicit Init_HRIMessage_audios(::rai_interfaces::msg::HRIMessage & msg)
  : msg_(msg)
  {}
  Init_HRIMessage_communication_id audios(::rai_interfaces::msg::HRIMessage::_audios_type arg)
  {
    msg_.audios = std::move(arg);
    return Init_HRIMessage_communication_id(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

class Init_HRIMessage_images
{
public:
  explicit Init_HRIMessage_images(::rai_interfaces::msg::HRIMessage & msg)
  : msg_(msg)
  {}
  Init_HRIMessage_audios images(::rai_interfaces::msg::HRIMessage::_images_type arg)
  {
    msg_.images = std::move(arg);
    return Init_HRIMessage_audios(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

class Init_HRIMessage_text
{
public:
  explicit Init_HRIMessage_text(::rai_interfaces::msg::HRIMessage & msg)
  : msg_(msg)
  {}
  Init_HRIMessage_images text(::rai_interfaces::msg::HRIMessage::_text_type arg)
  {
    msg_.text = std::move(arg);
    return Init_HRIMessage_images(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

class Init_HRIMessage_header
{
public:
  Init_HRIMessage_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_HRIMessage_text header(::rai_interfaces::msg::HRIMessage::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_HRIMessage_text(msg_);
  }

private:
  ::rai_interfaces::msg::HRIMessage msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::msg::HRIMessage>()
{
  return rai_interfaces::msg::builder::Init_HRIMessage_header();
}

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__BUILDER_HPP_
