// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:msg/HRIMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__STRUCT_HPP_
#define RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'images'
#include "sensor_msgs/msg/detail/image__struct.hpp"
// Member 'audios'
#include "rai_interfaces/msg/detail/audio_message__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__msg__HRIMessage __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__msg__HRIMessage __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HRIMessage_
{
  using Type = HRIMessage_<ContainerAllocator>;

  explicit HRIMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->text = "";
      this->communication_id = "";
      this->seq_no = 0ll;
      this->seq_end = false;
    }
  }

  explicit HRIMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    text(_alloc),
    communication_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->text = "";
      this->communication_id = "";
      this->seq_no = 0ll;
      this->seq_end = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _text_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _text_type text;
  using _images_type =
    std::vector<sensor_msgs::msg::Image_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<sensor_msgs::msg::Image_<ContainerAllocator>>>;
  _images_type images;
  using _audios_type =
    std::vector<rai_interfaces::msg::AudioMessage_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rai_interfaces::msg::AudioMessage_<ContainerAllocator>>>;
  _audios_type audios;
  using _communication_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _communication_id_type communication_id;
  using _seq_no_type =
    int64_t;
  _seq_no_type seq_no;
  using _seq_end_type =
    bool;
  _seq_end_type seq_end;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__text(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->text = _arg;
    return *this;
  }
  Type & set__images(
    const std::vector<sensor_msgs::msg::Image_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<sensor_msgs::msg::Image_<ContainerAllocator>>> & _arg)
  {
    this->images = _arg;
    return *this;
  }
  Type & set__audios(
    const std::vector<rai_interfaces::msg::AudioMessage_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rai_interfaces::msg::AudioMessage_<ContainerAllocator>>> & _arg)
  {
    this->audios = _arg;
    return *this;
  }
  Type & set__communication_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->communication_id = _arg;
    return *this;
  }
  Type & set__seq_no(
    const int64_t & _arg)
  {
    this->seq_no = _arg;
    return *this;
  }
  Type & set__seq_end(
    const bool & _arg)
  {
    this->seq_end = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::msg::HRIMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::msg::HRIMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::msg::HRIMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::msg::HRIMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__msg__HRIMessage
    std::shared_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__msg__HRIMessage
    std::shared_ptr<rai_interfaces::msg::HRIMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HRIMessage_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->text != other.text) {
      return false;
    }
    if (this->images != other.images) {
      return false;
    }
    if (this->audios != other.audios) {
      return false;
    }
    if (this->communication_id != other.communication_id) {
      return false;
    }
    if (this->seq_no != other.seq_no) {
      return false;
    }
    if (this->seq_end != other.seq_end) {
      return false;
    }
    return true;
  }
  bool operator!=(const HRIMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HRIMessage_

// alias to use template instance with default allocator
using HRIMessage =
  rai_interfaces::msg::HRIMessage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__STRUCT_HPP_
