// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:msg/HRIMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__TRAITS_HPP_
#define RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/msg/detail/hri_message__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'images'
#include "sensor_msgs/msg/detail/image__traits.hpp"
// Member 'audios'
#include "rai_interfaces/msg/detail/audio_message__traits.hpp"

namespace rai_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const HRIMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: text
  {
    out << "text: ";
    rosidl_generator_traits::value_to_yaml(msg.text, out);
    out << ", ";
  }

  // member: images
  {
    if (msg.images.size() == 0) {
      out << "images: []";
    } else {
      out << "images: [";
      size_t pending_items = msg.images.size();
      for (auto item : msg.images) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: audios
  {
    if (msg.audios.size() == 0) {
      out << "audios: []";
    } else {
      out << "audios: [";
      size_t pending_items = msg.audios.size();
      for (auto item : msg.audios) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: communication_id
  {
    out << "communication_id: ";
    rosidl_generator_traits::value_to_yaml(msg.communication_id, out);
    out << ", ";
  }

  // member: seq_no
  {
    out << "seq_no: ";
    rosidl_generator_traits::value_to_yaml(msg.seq_no, out);
    out << ", ";
  }

  // member: seq_end
  {
    out << "seq_end: ";
    rosidl_generator_traits::value_to_yaml(msg.seq_end, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const HRIMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: text
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "text: ";
    rosidl_generator_traits::value_to_yaml(msg.text, out);
    out << "\n";
  }

  // member: images
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.images.size() == 0) {
      out << "images: []\n";
    } else {
      out << "images:\n";
      for (auto item : msg.images) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: audios
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.audios.size() == 0) {
      out << "audios: []\n";
    } else {
      out << "audios:\n";
      for (auto item : msg.audios) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: communication_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "communication_id: ";
    rosidl_generator_traits::value_to_yaml(msg.communication_id, out);
    out << "\n";
  }

  // member: seq_no
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seq_no: ";
    rosidl_generator_traits::value_to_yaml(msg.seq_no, out);
    out << "\n";
  }

  // member: seq_end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seq_end: ";
    rosidl_generator_traits::value_to_yaml(msg.seq_end, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const HRIMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::msg::HRIMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::msg::HRIMessage & msg)
{
  return rai_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::msg::HRIMessage>()
{
  return "rai_interfaces::msg::HRIMessage";
}

template<>
inline const char * name<rai_interfaces::msg::HRIMessage>()
{
  return "rai_interfaces/msg/HRIMessage";
}

template<>
struct has_fixed_size<rai_interfaces::msg::HRIMessage>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::msg::HRIMessage>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::msg::HRIMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__TRAITS_HPP_
