// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rai_interfaces:msg/HRIMessage.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rai_interfaces/msg/detail/hri_message__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rai_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void HRIMessage_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rai_interfaces::msg::HRIMessage(_init);
}

void HRIMessage_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rai_interfaces::msg::HRIMessage *>(message_memory);
  typed_message->~HRIMessage();
}

size_t size_function__HRIMessage__images(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HRIMessage__images(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  return &member[index];
}

void * get_function__HRIMessage__images(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  return &member[index];
}

void fetch_function__HRIMessage__images(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const sensor_msgs::msg::Image *>(
    get_const_function__HRIMessage__images(untyped_member, index));
  auto & value = *reinterpret_cast<sensor_msgs::msg::Image *>(untyped_value);
  value = item;
}

void assign_function__HRIMessage__images(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<sensor_msgs::msg::Image *>(
    get_function__HRIMessage__images(untyped_member, index));
  const auto & value = *reinterpret_cast<const sensor_msgs::msg::Image *>(untyped_value);
  item = value;
}

void resize_function__HRIMessage__images(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  member->resize(size);
}

size_t size_function__HRIMessage__audios(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rai_interfaces::msg::AudioMessage> *>(untyped_member);
  return member->size();
}

const void * get_const_function__HRIMessage__audios(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rai_interfaces::msg::AudioMessage> *>(untyped_member);
  return &member[index];
}

void * get_function__HRIMessage__audios(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rai_interfaces::msg::AudioMessage> *>(untyped_member);
  return &member[index];
}

void fetch_function__HRIMessage__audios(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const rai_interfaces::msg::AudioMessage *>(
    get_const_function__HRIMessage__audios(untyped_member, index));
  auto & value = *reinterpret_cast<rai_interfaces::msg::AudioMessage *>(untyped_value);
  value = item;
}

void assign_function__HRIMessage__audios(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<rai_interfaces::msg::AudioMessage *>(
    get_function__HRIMessage__audios(untyped_member, index));
  const auto & value = *reinterpret_cast<const rai_interfaces::msg::AudioMessage *>(untyped_value);
  item = value;
}

void resize_function__HRIMessage__audios(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rai_interfaces::msg::AudioMessage> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember HRIMessage_message_member_array[7] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "text",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, text),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "images",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<sensor_msgs::msg::Image>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, images),  // bytes offset in struct
    nullptr,  // default value
    size_function__HRIMessage__images,  // size() function pointer
    get_const_function__HRIMessage__images,  // get_const(index) function pointer
    get_function__HRIMessage__images,  // get(index) function pointer
    fetch_function__HRIMessage__images,  // fetch(index, &value) function pointer
    assign_function__HRIMessage__images,  // assign(index, value) function pointer
    resize_function__HRIMessage__images  // resize(index) function pointer
  },
  {
    "audios",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rai_interfaces::msg::AudioMessage>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, audios),  // bytes offset in struct
    nullptr,  // default value
    size_function__HRIMessage__audios,  // size() function pointer
    get_const_function__HRIMessage__audios,  // get_const(index) function pointer
    get_function__HRIMessage__audios,  // get(index) function pointer
    fetch_function__HRIMessage__audios,  // fetch(index, &value) function pointer
    assign_function__HRIMessage__audios,  // assign(index, value) function pointer
    resize_function__HRIMessage__audios  // resize(index) function pointer
  },
  {
    "communication_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, communication_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "seq_no",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, seq_no),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "seq_end",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::HRIMessage, seq_end),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers HRIMessage_message_members = {
  "rai_interfaces::msg",  // message namespace
  "HRIMessage",  // message name
  7,  // number of fields
  sizeof(rai_interfaces::msg::HRIMessage),
  HRIMessage_message_member_array,  // message members
  HRIMessage_init_function,  // function to initialize message memory (memory has to be allocated)
  HRIMessage_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t HRIMessage_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &HRIMessage_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace rai_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rai_interfaces::msg::HRIMessage>()
{
  return &::rai_interfaces::msg::rosidl_typesupport_introspection_cpp::HRIMessage_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rai_interfaces, msg, HRIMessage)() {
  return &::rai_interfaces::msg::rosidl_typesupport_introspection_cpp::HRIMessage_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
