// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:msg/RAIDetectionArray.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__TRAITS_HPP_
#define RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/msg/detail/rai_detection_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'detections'
#include "vision_msgs/msg/detail/detection2_d__traits.hpp"

namespace rai_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RAIDetectionArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: detections
  {
    if (msg.detections.size() == 0) {
      out << "detections: []";
    } else {
      out << "detections: [";
      size_t pending_items = msg.detections.size();
      for (auto item : msg.detections) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: detection_classes
  {
    if (msg.detection_classes.size() == 0) {
      out << "detection_classes: []";
    } else {
      out << "detection_classes: [";
      size_t pending_items = msg.detection_classes.size();
      for (auto item : msg.detection_classes) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RAIDetectionArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: detections
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.detections.size() == 0) {
      out << "detections: []\n";
    } else {
      out << "detections:\n";
      for (auto item : msg.detections) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: detection_classes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.detection_classes.size() == 0) {
      out << "detection_classes: []\n";
    } else {
      out << "detection_classes:\n";
      for (auto item : msg.detection_classes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RAIDetectionArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::msg::RAIDetectionArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::msg::RAIDetectionArray & msg)
{
  return rai_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::msg::RAIDetectionArray>()
{
  return "rai_interfaces::msg::RAIDetectionArray";
}

template<>
inline const char * name<rai_interfaces::msg::RAIDetectionArray>()
{
  return "rai_interfaces/msg/RAIDetectionArray";
}

template<>
struct has_fixed_size<rai_interfaces::msg::RAIDetectionArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::msg::RAIDetectionArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::msg::RAIDetectionArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__TRAITS_HPP_
