// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rai_interfaces:msg/RAIDetectionArray.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rai_interfaces/msg/detail/rai_detection_array__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rai_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void RAIDetectionArray_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rai_interfaces::msg::RAIDetectionArray(_init);
}

void RAIDetectionArray_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rai_interfaces::msg::RAIDetectionArray *>(message_memory);
  typed_message->~RAIDetectionArray();
}

size_t size_function__RAIDetectionArray__detections(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<vision_msgs::msg::Detection2D> *>(untyped_member);
  return member->size();
}

const void * get_const_function__RAIDetectionArray__detections(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<vision_msgs::msg::Detection2D> *>(untyped_member);
  return &member[index];
}

void * get_function__RAIDetectionArray__detections(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<vision_msgs::msg::Detection2D> *>(untyped_member);
  return &member[index];
}

void fetch_function__RAIDetectionArray__detections(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const vision_msgs::msg::Detection2D *>(
    get_const_function__RAIDetectionArray__detections(untyped_member, index));
  auto & value = *reinterpret_cast<vision_msgs::msg::Detection2D *>(untyped_value);
  value = item;
}

void assign_function__RAIDetectionArray__detections(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<vision_msgs::msg::Detection2D *>(
    get_function__RAIDetectionArray__detections(untyped_member, index));
  const auto & value = *reinterpret_cast<const vision_msgs::msg::Detection2D *>(untyped_value);
  item = value;
}

void resize_function__RAIDetectionArray__detections(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<vision_msgs::msg::Detection2D> *>(untyped_member);
  member->resize(size);
}

size_t size_function__RAIDetectionArray__detection_classes(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return member->size();
}

const void * get_const_function__RAIDetectionArray__detection_classes(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void * get_function__RAIDetectionArray__detection_classes(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<std::string> *>(untyped_member);
  return &member[index];
}

void fetch_function__RAIDetectionArray__detection_classes(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const std::string *>(
    get_const_function__RAIDetectionArray__detection_classes(untyped_member, index));
  auto & value = *reinterpret_cast<std::string *>(untyped_value);
  value = item;
}

void assign_function__RAIDetectionArray__detection_classes(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<std::string *>(
    get_function__RAIDetectionArray__detection_classes(untyped_member, index));
  const auto & value = *reinterpret_cast<const std::string *>(untyped_value);
  item = value;
}

void resize_function__RAIDetectionArray__detection_classes(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<std::string> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RAIDetectionArray_message_member_array[3] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::RAIDetectionArray, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "detections",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<vision_msgs::msg::Detection2D>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::RAIDetectionArray, detections),  // bytes offset in struct
    nullptr,  // default value
    size_function__RAIDetectionArray__detections,  // size() function pointer
    get_const_function__RAIDetectionArray__detections,  // get_const(index) function pointer
    get_function__RAIDetectionArray__detections,  // get(index) function pointer
    fetch_function__RAIDetectionArray__detections,  // fetch(index, &value) function pointer
    assign_function__RAIDetectionArray__detections,  // assign(index, value) function pointer
    resize_function__RAIDetectionArray__detections  // resize(index) function pointer
  },
  {
    "detection_classes",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::RAIDetectionArray, detection_classes),  // bytes offset in struct
    nullptr,  // default value
    size_function__RAIDetectionArray__detection_classes,  // size() function pointer
    get_const_function__RAIDetectionArray__detection_classes,  // get_const(index) function pointer
    get_function__RAIDetectionArray__detection_classes,  // get(index) function pointer
    fetch_function__RAIDetectionArray__detection_classes,  // fetch(index, &value) function pointer
    assign_function__RAIDetectionArray__detection_classes,  // assign(index, value) function pointer
    resize_function__RAIDetectionArray__detection_classes  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RAIDetectionArray_message_members = {
  "rai_interfaces::msg",  // message namespace
  "RAIDetectionArray",  // message name
  3,  // number of fields
  sizeof(rai_interfaces::msg::RAIDetectionArray),
  RAIDetectionArray_message_member_array,  // message members
  RAIDetectionArray_init_function,  // function to initialize message memory (memory has to be allocated)
  RAIDetectionArray_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RAIDetectionArray_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RAIDetectionArray_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace rai_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rai_interfaces::msg::RAIDetectionArray>()
{
  return &::rai_interfaces::msg::rosidl_typesupport_introspection_cpp::RAIDetectionArray_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rai_interfaces, msg, RAIDetectionArray)() {
  return &::rai_interfaces::msg::rosidl_typesupport_introspection_cpp::RAIDetectionArray_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
