// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:srv/ManipulatorMoveTo.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__STRUCT_HPP_
#define RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'target_pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Request __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Request __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ManipulatorMoveTo_Request_
{
  using Type = ManipulatorMoveTo_Request_<ContainerAllocator>;

  explicit ManipulatorMoveTo_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target_pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->initial_gripper_state = false;
      this->final_gripper_state = false;
    }
  }

  explicit ManipulatorMoveTo_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target_pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->initial_gripper_state = false;
      this->final_gripper_state = false;
    }
  }

  // field types and members
  using _initial_gripper_state_type =
    bool;
  _initial_gripper_state_type initial_gripper_state;
  using _final_gripper_state_type =
    bool;
  _final_gripper_state_type final_gripper_state;
  using _target_pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _target_pose_type target_pose;

  // setters for named parameter idiom
  Type & set__initial_gripper_state(
    const bool & _arg)
  {
    this->initial_gripper_state = _arg;
    return *this;
  }
  Type & set__final_gripper_state(
    const bool & _arg)
  {
    this->final_gripper_state = _arg;
    return *this;
  }
  Type & set__target_pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->target_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Request
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Request
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManipulatorMoveTo_Request_ & other) const
  {
    if (this->initial_gripper_state != other.initial_gripper_state) {
      return false;
    }
    if (this->final_gripper_state != other.final_gripper_state) {
      return false;
    }
    if (this->target_pose != other.target_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManipulatorMoveTo_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManipulatorMoveTo_Request_

// alias to use template instance with default allocator
using ManipulatorMoveTo_Request =
  rai_interfaces::srv::ManipulatorMoveTo_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Response __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Response __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ManipulatorMoveTo_Response_
{
  using Type = ManipulatorMoveTo_Response_<ContainerAllocator>;

  explicit ManipulatorMoveTo_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit ManipulatorMoveTo_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Response
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__ManipulatorMoveTo_Response
    std::shared_ptr<rai_interfaces::srv::ManipulatorMoveTo_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManipulatorMoveTo_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManipulatorMoveTo_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManipulatorMoveTo_Response_

// alias to use template instance with default allocator
using ManipulatorMoveTo_Response =
  rai_interfaces::srv::ManipulatorMoveTo_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces

namespace rai_interfaces
{

namespace srv
{

struct ManipulatorMoveTo
{
  using Request = rai_interfaces::srv::ManipulatorMoveTo_Request;
  using Response = rai_interfaces::srv::ManipulatorMoveTo_Response;
};

}  // namespace srv

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__STRUCT_HPP_
