// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/ManipulatorMoveTo.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/manipulator_move_to__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'target_pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const ManipulatorMoveTo_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: initial_gripper_state
  {
    out << "initial_gripper_state: ";
    rosidl_generator_traits::value_to_yaml(msg.initial_gripper_state, out);
    out << ", ";
  }

  // member: final_gripper_state
  {
    out << "final_gripper_state: ";
    rosidl_generator_traits::value_to_yaml(msg.final_gripper_state, out);
    out << ", ";
  }

  // member: target_pose
  {
    out << "target_pose: ";
    to_flow_style_yaml(msg.target_pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ManipulatorMoveTo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: initial_gripper_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "initial_gripper_state: ";
    rosidl_generator_traits::value_to_yaml(msg.initial_gripper_state, out);
    out << "\n";
  }

  // member: final_gripper_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "final_gripper_state: ";
    rosidl_generator_traits::value_to_yaml(msg.final_gripper_state, out);
    out << "\n";
  }

  // member: target_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target_pose:\n";
    to_block_style_yaml(msg.target_pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ManipulatorMoveTo_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::ManipulatorMoveTo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::ManipulatorMoveTo_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::ManipulatorMoveTo_Request>()
{
  return "rai_interfaces::srv::ManipulatorMoveTo_Request";
}

template<>
inline const char * name<rai_interfaces::srv::ManipulatorMoveTo_Request>()
{
  return "rai_interfaces/srv/ManipulatorMoveTo_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::ManipulatorMoveTo_Request>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PoseStamped>::value> {};

template<>
struct has_bounded_size<rai_interfaces::srv::ManipulatorMoveTo_Request>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PoseStamped>::value> {};

template<>
struct is_message<rai_interfaces::srv::ManipulatorMoveTo_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const ManipulatorMoveTo_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ManipulatorMoveTo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ManipulatorMoveTo_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::ManipulatorMoveTo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::ManipulatorMoveTo_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::ManipulatorMoveTo_Response>()
{
  return "rai_interfaces::srv::ManipulatorMoveTo_Response";
}

template<>
inline const char * name<rai_interfaces::srv::ManipulatorMoveTo_Response>()
{
  return "rai_interfaces/srv/ManipulatorMoveTo_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::ManipulatorMoveTo_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rai_interfaces::srv::ManipulatorMoveTo_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rai_interfaces::srv::ManipulatorMoveTo_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::ManipulatorMoveTo>()
{
  return "rai_interfaces::srv::ManipulatorMoveTo";
}

template<>
inline const char * name<rai_interfaces::srv::ManipulatorMoveTo>()
{
  return "rai_interfaces/srv/ManipulatorMoveTo";
}

template<>
struct has_fixed_size<rai_interfaces::srv::ManipulatorMoveTo>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::ManipulatorMoveTo_Request>::value &&
    has_fixed_size<rai_interfaces::srv::ManipulatorMoveTo_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::ManipulatorMoveTo>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::ManipulatorMoveTo_Request>::value &&
    has_bounded_size<rai_interfaces::srv::ManipulatorMoveTo_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::ManipulatorMoveTo>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::ManipulatorMoveTo_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::ManipulatorMoveTo_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__TRAITS_HPP_
