// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:srv/RAIGroundedSam.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDED_SAM__STRUCT_HPP_
#define RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDED_SAM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'detections'
#include "rai_interfaces/msg/detail/rai_detection_array__struct.hpp"
// Member 'source_img'
#include "sensor_msgs/msg/detail/image__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Request __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Request __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RAIGroundedSam_Request_
{
  using Type = RAIGroundedSam_Request_<ContainerAllocator>;

  explicit RAIGroundedSam_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : detections(_init),
    source_img(_init)
  {
    (void)_init;
  }

  explicit RAIGroundedSam_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : detections(_alloc, _init),
    source_img(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _detections_type =
    rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>;
  _detections_type detections;
  using _source_img_type =
    sensor_msgs::msg::Image_<ContainerAllocator>;
  _source_img_type source_img;

  // setters for named parameter idiom
  Type & set__detections(
    const rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> & _arg)
  {
    this->detections = _arg;
    return *this;
  }
  Type & set__source_img(
    const sensor_msgs::msg::Image_<ContainerAllocator> & _arg)
  {
    this->source_img = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Request
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Request
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RAIGroundedSam_Request_ & other) const
  {
    if (this->detections != other.detections) {
      return false;
    }
    if (this->source_img != other.source_img) {
      return false;
    }
    return true;
  }
  bool operator!=(const RAIGroundedSam_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RAIGroundedSam_Request_

// alias to use template instance with default allocator
using RAIGroundedSam_Request =
  rai_interfaces::srv::RAIGroundedSam_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


// Include directives for member types
// Member 'masks'
// already included above
// #include "sensor_msgs/msg/detail/image__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Response __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Response __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RAIGroundedSam_Response_
{
  using Type = RAIGroundedSam_Response_<ContainerAllocator>;

  explicit RAIGroundedSam_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit RAIGroundedSam_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _masks_type =
    std::vector<sensor_msgs::msg::Image_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<sensor_msgs::msg::Image_<ContainerAllocator>>>;
  _masks_type masks;

  // setters for named parameter idiom
  Type & set__masks(
    const std::vector<sensor_msgs::msg::Image_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<sensor_msgs::msg::Image_<ContainerAllocator>>> & _arg)
  {
    this->masks = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Response
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundedSam_Response
    std::shared_ptr<rai_interfaces::srv::RAIGroundedSam_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RAIGroundedSam_Response_ & other) const
  {
    if (this->masks != other.masks) {
      return false;
    }
    return true;
  }
  bool operator!=(const RAIGroundedSam_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RAIGroundedSam_Response_

// alias to use template instance with default allocator
using RAIGroundedSam_Response =
  rai_interfaces::srv::RAIGroundedSam_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces

namespace rai_interfaces
{

namespace srv
{

struct RAIGroundedSam
{
  using Request = rai_interfaces::srv::RAIGroundedSam_Request;
  using Response = rai_interfaces::srv::RAIGroundedSam_Response;
};

}  // namespace srv

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDED_SAM__STRUCT_HPP_
