// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rai_interfaces:srv/RAIGroundedSam.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rai_interfaces/srv/detail/rai_grounded_sam__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rai_interfaces
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void RAIGroundedSam_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rai_interfaces::srv::RAIGroundedSam_Request(_init);
}

void RAIGroundedSam_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rai_interfaces::srv::RAIGroundedSam_Request *>(message_memory);
  typed_message->~RAIGroundedSam_Request();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RAIGroundedSam_Request_message_member_array[2] = {
  {
    "detections",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rai_interfaces::msg::RAIDetectionArray>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::srv::RAIGroundedSam_Request, detections),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "source_img",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<sensor_msgs::msg::Image>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::srv::RAIGroundedSam_Request, source_img),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RAIGroundedSam_Request_message_members = {
  "rai_interfaces::srv",  // message namespace
  "RAIGroundedSam_Request",  // message name
  2,  // number of fields
  sizeof(rai_interfaces::srv::RAIGroundedSam_Request),
  RAIGroundedSam_Request_message_member_array,  // message members
  RAIGroundedSam_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  RAIGroundedSam_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RAIGroundedSam_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RAIGroundedSam_Request_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rai_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rai_interfaces::srv::RAIGroundedSam_Request>()
{
  return &::rai_interfaces::srv::rosidl_typesupport_introspection_cpp::RAIGroundedSam_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rai_interfaces, srv, RAIGroundedSam_Request)() {
  return &::rai_interfaces::srv::rosidl_typesupport_introspection_cpp::RAIGroundedSam_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rai_interfaces/srv/detail/rai_grounded_sam__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rai_interfaces
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void RAIGroundedSam_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rai_interfaces::srv::RAIGroundedSam_Response(_init);
}

void RAIGroundedSam_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rai_interfaces::srv::RAIGroundedSam_Response *>(message_memory);
  typed_message->~RAIGroundedSam_Response();
}

size_t size_function__RAIGroundedSam_Response__masks(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  return member->size();
}

const void * get_const_function__RAIGroundedSam_Response__masks(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  return &member[index];
}

void * get_function__RAIGroundedSam_Response__masks(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  return &member[index];
}

void fetch_function__RAIGroundedSam_Response__masks(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const sensor_msgs::msg::Image *>(
    get_const_function__RAIGroundedSam_Response__masks(untyped_member, index));
  auto & value = *reinterpret_cast<sensor_msgs::msg::Image *>(untyped_value);
  value = item;
}

void assign_function__RAIGroundedSam_Response__masks(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<sensor_msgs::msg::Image *>(
    get_function__RAIGroundedSam_Response__masks(untyped_member, index));
  const auto & value = *reinterpret_cast<const sensor_msgs::msg::Image *>(untyped_value);
  item = value;
}

void resize_function__RAIGroundedSam_Response__masks(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<sensor_msgs::msg::Image> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RAIGroundedSam_Response_message_member_array[1] = {
  {
    "masks",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<sensor_msgs::msg::Image>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::srv::RAIGroundedSam_Response, masks),  // bytes offset in struct
    nullptr,  // default value
    size_function__RAIGroundedSam_Response__masks,  // size() function pointer
    get_const_function__RAIGroundedSam_Response__masks,  // get_const(index) function pointer
    get_function__RAIGroundedSam_Response__masks,  // get(index) function pointer
    fetch_function__RAIGroundedSam_Response__masks,  // fetch(index, &value) function pointer
    assign_function__RAIGroundedSam_Response__masks,  // assign(index, value) function pointer
    resize_function__RAIGroundedSam_Response__masks  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RAIGroundedSam_Response_message_members = {
  "rai_interfaces::srv",  // message namespace
  "RAIGroundedSam_Response",  // message name
  1,  // number of fields
  sizeof(rai_interfaces::srv::RAIGroundedSam_Response),
  RAIGroundedSam_Response_message_member_array,  // message members
  RAIGroundedSam_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  RAIGroundedSam_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RAIGroundedSam_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RAIGroundedSam_Response_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rai_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rai_interfaces::srv::RAIGroundedSam_Response>()
{
  return &::rai_interfaces::srv::rosidl_typesupport_introspection_cpp::RAIGroundedSam_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rai_interfaces, srv, RAIGroundedSam_Response)() {
  return &::rai_interfaces::srv::rosidl_typesupport_introspection_cpp::RAIGroundedSam_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

#include "rosidl_runtime_c/service_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "rai_interfaces/srv/detail/rai_grounded_sam__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace rai_interfaces
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers RAIGroundedSam_service_members = {
  "rai_interfaces::srv",  // service namespace
  "RAIGroundedSam",  // service name
  // these two fields are initialized below on the first access
  // see get_service_type_support_handle<rai_interfaces::srv::RAIGroundedSam>()
  nullptr,  // request message
  nullptr  // response message
};

static const rosidl_service_type_support_t RAIGroundedSam_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RAIGroundedSam_service_members,
  get_service_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace rai_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<rai_interfaces::srv::RAIGroundedSam>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::rai_interfaces::srv::rosidl_typesupport_introspection_cpp::RAIGroundedSam_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure that both the request_members_ and the response_members_ are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rai_interfaces::srv::RAIGroundedSam_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::rai_interfaces::srv::RAIGroundedSam_Response
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rai_interfaces, srv, RAIGroundedSam)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<rai_interfaces::srv::RAIGroundedSam>();
}

#ifdef __cplusplus
}
#endif
