// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:srv/VectorStoreRetrieval.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__STRUCT_HPP_
#define RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Request __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Request __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct VectorStoreRetrieval_Request_
{
  using Type = VectorStoreRetrieval_Request_<ContainerAllocator>;

  explicit VectorStoreRetrieval_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->query = "";
    }
  }

  explicit VectorStoreRetrieval_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : query(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->query = "";
    }
  }

  // field types and members
  using _query_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _query_type query;

  // setters for named parameter idiom
  Type & set__query(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->query = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Request
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Request
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VectorStoreRetrieval_Request_ & other) const
  {
    if (this->query != other.query) {
      return false;
    }
    return true;
  }
  bool operator!=(const VectorStoreRetrieval_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VectorStoreRetrieval_Request_

// alias to use template instance with default allocator
using VectorStoreRetrieval_Request =
  rai_interfaces::srv::VectorStoreRetrieval_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Response __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Response __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct VectorStoreRetrieval_Response_
{
  using Type = VectorStoreRetrieval_Response_<ContainerAllocator>;

  explicit VectorStoreRetrieval_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit VectorStoreRetrieval_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;
  using _documents_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _documents_type documents;
  using _scores_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _scores_type scores;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }
  Type & set__documents(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->documents = _arg;
    return *this;
  }
  Type & set__scores(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->scores = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Response
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__VectorStoreRetrieval_Response
    std::shared_ptr<rai_interfaces::srv::VectorStoreRetrieval_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VectorStoreRetrieval_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    if (this->documents != other.documents) {
      return false;
    }
    if (this->scores != other.scores) {
      return false;
    }
    return true;
  }
  bool operator!=(const VectorStoreRetrieval_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VectorStoreRetrieval_Response_

// alias to use template instance with default allocator
using VectorStoreRetrieval_Response =
  rai_interfaces::srv::VectorStoreRetrieval_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces

namespace rai_interfaces
{

namespace srv
{

struct VectorStoreRetrieval
{
  using Request = rai_interfaces::srv::VectorStoreRetrieval_Request;
  using Response = rai_interfaces::srv::VectorStoreRetrieval_Response;
};

}  // namespace srv

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__STRUCT_HPP_
