// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/VectorStoreRetrieval.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/vector_store_retrieval__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const VectorStoreRetrieval_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: query
  {
    out << "query: ";
    rosidl_generator_traits::value_to_yaml(msg.query, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VectorStoreRetrieval_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: query
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "query: ";
    rosidl_generator_traits::value_to_yaml(msg.query, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VectorStoreRetrieval_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::VectorStoreRetrieval_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::VectorStoreRetrieval_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::VectorStoreRetrieval_Request>()
{
  return "rai_interfaces::srv::VectorStoreRetrieval_Request";
}

template<>
inline const char * name<rai_interfaces::srv::VectorStoreRetrieval_Request>()
{
  return "rai_interfaces/srv/VectorStoreRetrieval_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::VectorStoreRetrieval_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::VectorStoreRetrieval_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::VectorStoreRetrieval_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const VectorStoreRetrieval_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << ", ";
  }

  // member: documents
  {
    if (msg.documents.size() == 0) {
      out << "documents: []";
    } else {
      out << "documents: [";
      size_t pending_items = msg.documents.size();
      for (auto item : msg.documents) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: scores
  {
    if (msg.scores.size() == 0) {
      out << "scores: []";
    } else {
      out << "scores: [";
      size_t pending_items = msg.scores.size();
      for (auto item : msg.scores) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VectorStoreRetrieval_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }

  // member: documents
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.documents.size() == 0) {
      out << "documents: []\n";
    } else {
      out << "documents:\n";
      for (auto item : msg.documents) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: scores
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.scores.size() == 0) {
      out << "scores: []\n";
    } else {
      out << "scores:\n";
      for (auto item : msg.scores) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VectorStoreRetrieval_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::VectorStoreRetrieval_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::VectorStoreRetrieval_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::VectorStoreRetrieval_Response>()
{
  return "rai_interfaces::srv::VectorStoreRetrieval_Response";
}

template<>
inline const char * name<rai_interfaces::srv::VectorStoreRetrieval_Response>()
{
  return "rai_interfaces/srv/VectorStoreRetrieval_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::VectorStoreRetrieval_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::VectorStoreRetrieval_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::VectorStoreRetrieval_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::VectorStoreRetrieval>()
{
  return "rai_interfaces::srv::VectorStoreRetrieval";
}

template<>
inline const char * name<rai_interfaces::srv::VectorStoreRetrieval>()
{
  return "rai_interfaces/srv/VectorStoreRetrieval";
}

template<>
struct has_fixed_size<rai_interfaces::srv::VectorStoreRetrieval>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::VectorStoreRetrieval_Request>::value &&
    has_fixed_size<rai_interfaces::srv::VectorStoreRetrieval_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::VectorStoreRetrieval>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::VectorStoreRetrieval_Request>::value &&
    has_bounded_size<rai_interfaces::srv::VectorStoreRetrieval_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::VectorStoreRetrieval>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::VectorStoreRetrieval_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::VectorStoreRetrieval_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__TRAITS_HPP_
