// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/WhatISee.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__WHAT_I_SEE__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__WHAT_I_SEE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/what_i_see__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const WhatISee_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const WhatISee_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const WhatISee_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::WhatISee_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::WhatISee_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::WhatISee_Request>()
{
  return "rai_interfaces::srv::WhatISee_Request";
}

template<>
inline const char * name<rai_interfaces::srv::WhatISee_Request>()
{
  return "rai_interfaces/srv/WhatISee_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::WhatISee_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rai_interfaces::srv::WhatISee_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rai_interfaces::srv::WhatISee_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'image'
#include "sensor_msgs/msg/detail/image__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const WhatISee_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: observations
  {
    if (msg.observations.size() == 0) {
      out << "observations: []";
    } else {
      out << "observations: [";
      size_t pending_items = msg.observations.size();
      for (auto item : msg.observations) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: perception_source
  {
    out << "perception_source: ";
    rosidl_generator_traits::value_to_yaml(msg.perception_source, out);
    out << ", ";
  }

  // member: image
  {
    out << "image: ";
    to_flow_style_yaml(msg.image, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const WhatISee_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: observations
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.observations.size() == 0) {
      out << "observations: []\n";
    } else {
      out << "observations:\n";
      for (auto item : msg.observations) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: perception_source
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "perception_source: ";
    rosidl_generator_traits::value_to_yaml(msg.perception_source, out);
    out << "\n";
  }

  // member: image
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "image:\n";
    to_block_style_yaml(msg.image, out, indentation + 2);
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const WhatISee_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::WhatISee_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::WhatISee_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::WhatISee_Response>()
{
  return "rai_interfaces::srv::WhatISee_Response";
}

template<>
inline const char * name<rai_interfaces::srv::WhatISee_Response>()
{
  return "rai_interfaces/srv/WhatISee_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::WhatISee_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::WhatISee_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::WhatISee_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::WhatISee>()
{
  return "rai_interfaces::srv::WhatISee";
}

template<>
inline const char * name<rai_interfaces::srv::WhatISee>()
{
  return "rai_interfaces/srv/WhatISee";
}

template<>
struct has_fixed_size<rai_interfaces::srv::WhatISee>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::WhatISee_Request>::value &&
    has_fixed_size<rai_interfaces::srv::WhatISee_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::WhatISee>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::WhatISee_Request>::value &&
    has_bounded_size<rai_interfaces::srv::WhatISee_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::WhatISee>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::WhatISee_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::WhatISee_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__WHAT_I_SEE__TRAITS_HPP_
