// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rai_interfaces:action/TaskFeedback.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__ACTION__DETAIL__TASK_FEEDBACK__BUILDER_HPP_
#define RAI_INTERFACES__ACTION__DETAIL__TASK_FEEDBACK__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "rai_interfaces/action/detail/task_feedback__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_Goal_additional_info
{
public:
  explicit Init_TaskFeedback_Goal_additional_info(::rai_interfaces::action::TaskFeedback_Goal & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::TaskFeedback_Goal additional_info(::rai_interfaces::action::TaskFeedback_Goal::_additional_info_type arg)
  {
    msg_.additional_info = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_Goal msg_;
};

class Init_TaskFeedback_Goal_current_task
{
public:
  explicit Init_TaskFeedback_Goal_current_task(::rai_interfaces::action::TaskFeedback_Goal & msg)
  : msg_(msg)
  {}
  Init_TaskFeedback_Goal_additional_info current_task(::rai_interfaces::action::TaskFeedback_Goal::_current_task_type arg)
  {
    msg_.current_task = std::move(arg);
    return Init_TaskFeedback_Goal_additional_info(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_Goal msg_;
};

class Init_TaskFeedback_Goal_issue_description
{
public:
  Init_TaskFeedback_Goal_issue_description()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TaskFeedback_Goal_current_task issue_description(::rai_interfaces::action::TaskFeedback_Goal::_issue_description_type arg)
  {
    msg_.issue_description = std::move(arg);
    return Init_TaskFeedback_Goal_current_task(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_Goal>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_Goal_issue_description();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_Result_success
{
public:
  explicit Init_TaskFeedback_Result_success(::rai_interfaces::action::TaskFeedback_Result & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::TaskFeedback_Result success(::rai_interfaces::action::TaskFeedback_Result::_success_type arg)
  {
    msg_.success = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_Result msg_;
};

class Init_TaskFeedback_Result_informations
{
public:
  Init_TaskFeedback_Result_informations()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TaskFeedback_Result_success informations(::rai_interfaces::action::TaskFeedback_Result::_informations_type arg)
  {
    msg_.informations = std::move(arg);
    return Init_TaskFeedback_Result_success(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_Result>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_Result_informations();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_Feedback_feedback
{
public:
  Init_TaskFeedback_Feedback_feedback()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::rai_interfaces::action::TaskFeedback_Feedback feedback(::rai_interfaces::action::TaskFeedback_Feedback::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_Feedback>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_Feedback_feedback();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_SendGoal_Request_goal
{
public:
  explicit Init_TaskFeedback_SendGoal_Request_goal(::rai_interfaces::action::TaskFeedback_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::TaskFeedback_SendGoal_Request goal(::rai_interfaces::action::TaskFeedback_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_SendGoal_Request msg_;
};

class Init_TaskFeedback_SendGoal_Request_goal_id
{
public:
  Init_TaskFeedback_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TaskFeedback_SendGoal_Request_goal goal_id(::rai_interfaces::action::TaskFeedback_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_TaskFeedback_SendGoal_Request_goal(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_SendGoal_Request>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_SendGoal_Request_goal_id();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_SendGoal_Response_stamp
{
public:
  explicit Init_TaskFeedback_SendGoal_Response_stamp(::rai_interfaces::action::TaskFeedback_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::TaskFeedback_SendGoal_Response stamp(::rai_interfaces::action::TaskFeedback_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_SendGoal_Response msg_;
};

class Init_TaskFeedback_SendGoal_Response_accepted
{
public:
  Init_TaskFeedback_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TaskFeedback_SendGoal_Response_stamp accepted(::rai_interfaces::action::TaskFeedback_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_TaskFeedback_SendGoal_Response_stamp(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_SendGoal_Response>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_SendGoal_Response_accepted();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_GetResult_Request_goal_id
{
public:
  Init_TaskFeedback_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::rai_interfaces::action::TaskFeedback_GetResult_Request goal_id(::rai_interfaces::action::TaskFeedback_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_GetResult_Request>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_GetResult_Request_goal_id();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_GetResult_Response_result
{
public:
  explicit Init_TaskFeedback_GetResult_Response_result(::rai_interfaces::action::TaskFeedback_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::TaskFeedback_GetResult_Response result(::rai_interfaces::action::TaskFeedback_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_GetResult_Response msg_;
};

class Init_TaskFeedback_GetResult_Response_status
{
public:
  Init_TaskFeedback_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TaskFeedback_GetResult_Response_result status(::rai_interfaces::action::TaskFeedback_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_TaskFeedback_GetResult_Response_result(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_GetResult_Response>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_GetResult_Response_status();
}

}  // namespace rai_interfaces


namespace rai_interfaces
{

namespace action
{

namespace builder
{

class Init_TaskFeedback_FeedbackMessage_feedback
{
public:
  explicit Init_TaskFeedback_FeedbackMessage_feedback(::rai_interfaces::action::TaskFeedback_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::rai_interfaces::action::TaskFeedback_FeedbackMessage feedback(::rai_interfaces::action::TaskFeedback_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_FeedbackMessage msg_;
};

class Init_TaskFeedback_FeedbackMessage_goal_id
{
public:
  Init_TaskFeedback_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TaskFeedback_FeedbackMessage_feedback goal_id(::rai_interfaces::action::TaskFeedback_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_TaskFeedback_FeedbackMessage_feedback(msg_);
  }

private:
  ::rai_interfaces::action::TaskFeedback_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::rai_interfaces::action::TaskFeedback_FeedbackMessage>()
{
  return rai_interfaces::action::builder::Init_TaskFeedback_FeedbackMessage_goal_id();
}

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__ACTION__DETAIL__TASK_FEEDBACK__BUILDER_HPP_
