// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rai_interfaces:action/TaskFeedback.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__ACTION__DETAIL__TASK_FEEDBACK__FUNCTIONS_H_
#define RAI_INTERFACES__ACTION__DETAIL__TASK_FEEDBACK__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rai_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "rai_interfaces/action/detail/task_feedback__struct.h"

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_Goal
 * )) before or use
 * rai_interfaces__action__TaskFeedback_Goal__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Goal__init(rai_interfaces__action__TaskFeedback_Goal * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Goal__fini(rai_interfaces__action__TaskFeedback_Goal * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_Goal__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_Goal *
rai_interfaces__action__TaskFeedback_Goal__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Goal__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Goal__destroy(rai_interfaces__action__TaskFeedback_Goal * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Goal__are_equal(const rai_interfaces__action__TaskFeedback_Goal * lhs, const rai_interfaces__action__TaskFeedback_Goal * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Goal__copy(
  const rai_interfaces__action__TaskFeedback_Goal * input,
  rai_interfaces__action__TaskFeedback_Goal * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_Goal__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Goal__Sequence__init(rai_interfaces__action__TaskFeedback_Goal__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Goal__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Goal__Sequence__fini(rai_interfaces__action__TaskFeedback_Goal__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_Goal__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_Goal__Sequence *
rai_interfaces__action__TaskFeedback_Goal__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Goal__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Goal__Sequence__destroy(rai_interfaces__action__TaskFeedback_Goal__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Goal__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_Goal__Sequence * lhs, const rai_interfaces__action__TaskFeedback_Goal__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Goal__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_Goal__Sequence * input,
  rai_interfaces__action__TaskFeedback_Goal__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_Result
 * )) before or use
 * rai_interfaces__action__TaskFeedback_Result__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Result__init(rai_interfaces__action__TaskFeedback_Result * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Result__fini(rai_interfaces__action__TaskFeedback_Result * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_Result__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_Result *
rai_interfaces__action__TaskFeedback_Result__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Result__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Result__destroy(rai_interfaces__action__TaskFeedback_Result * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Result__are_equal(const rai_interfaces__action__TaskFeedback_Result * lhs, const rai_interfaces__action__TaskFeedback_Result * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Result__copy(
  const rai_interfaces__action__TaskFeedback_Result * input,
  rai_interfaces__action__TaskFeedback_Result * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_Result__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Result__Sequence__init(rai_interfaces__action__TaskFeedback_Result__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Result__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Result__Sequence__fini(rai_interfaces__action__TaskFeedback_Result__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_Result__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_Result__Sequence *
rai_interfaces__action__TaskFeedback_Result__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Result__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Result__Sequence__destroy(rai_interfaces__action__TaskFeedback_Result__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Result__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_Result__Sequence * lhs, const rai_interfaces__action__TaskFeedback_Result__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Result__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_Result__Sequence * input,
  rai_interfaces__action__TaskFeedback_Result__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_Feedback
 * )) before or use
 * rai_interfaces__action__TaskFeedback_Feedback__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Feedback__init(rai_interfaces__action__TaskFeedback_Feedback * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Feedback__fini(rai_interfaces__action__TaskFeedback_Feedback * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_Feedback__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_Feedback *
rai_interfaces__action__TaskFeedback_Feedback__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Feedback__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Feedback__destroy(rai_interfaces__action__TaskFeedback_Feedback * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Feedback__are_equal(const rai_interfaces__action__TaskFeedback_Feedback * lhs, const rai_interfaces__action__TaskFeedback_Feedback * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Feedback__copy(
  const rai_interfaces__action__TaskFeedback_Feedback * input,
  rai_interfaces__action__TaskFeedback_Feedback * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_Feedback__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Feedback__Sequence__init(rai_interfaces__action__TaskFeedback_Feedback__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Feedback__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Feedback__Sequence__fini(rai_interfaces__action__TaskFeedback_Feedback__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_Feedback__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_Feedback__Sequence *
rai_interfaces__action__TaskFeedback_Feedback__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_Feedback__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_Feedback__Sequence__destroy(rai_interfaces__action__TaskFeedback_Feedback__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Feedback__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_Feedback__Sequence * lhs, const rai_interfaces__action__TaskFeedback_Feedback__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_Feedback__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_Feedback__Sequence * input,
  rai_interfaces__action__TaskFeedback_Feedback__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_SendGoal_Request
 * )) before or use
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Request__init(rai_interfaces__action__TaskFeedback_SendGoal_Request * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Request__fini(rai_interfaces__action__TaskFeedback_SendGoal_Request * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_SendGoal_Request *
rai_interfaces__action__TaskFeedback_SendGoal_Request__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Request__destroy(rai_interfaces__action__TaskFeedback_SendGoal_Request * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Request__are_equal(const rai_interfaces__action__TaskFeedback_SendGoal_Request * lhs, const rai_interfaces__action__TaskFeedback_SendGoal_Request * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Request__copy(
  const rai_interfaces__action__TaskFeedback_SendGoal_Request * input,
  rai_interfaces__action__TaskFeedback_SendGoal_Request * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__init(rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__fini(rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence *
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__destroy(rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * lhs, const rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * input,
  rai_interfaces__action__TaskFeedback_SendGoal_Request__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_SendGoal_Response
 * )) before or use
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Response__init(rai_interfaces__action__TaskFeedback_SendGoal_Response * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Response__fini(rai_interfaces__action__TaskFeedback_SendGoal_Response * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_SendGoal_Response *
rai_interfaces__action__TaskFeedback_SendGoal_Response__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Response__destroy(rai_interfaces__action__TaskFeedback_SendGoal_Response * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Response__are_equal(const rai_interfaces__action__TaskFeedback_SendGoal_Response * lhs, const rai_interfaces__action__TaskFeedback_SendGoal_Response * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Response__copy(
  const rai_interfaces__action__TaskFeedback_SendGoal_Response * input,
  rai_interfaces__action__TaskFeedback_SendGoal_Response * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__init(rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__fini(rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence *
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__destroy(rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * lhs, const rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * input,
  rai_interfaces__action__TaskFeedback_SendGoal_Response__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_GetResult_Request
 * )) before or use
 * rai_interfaces__action__TaskFeedback_GetResult_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Request__init(rai_interfaces__action__TaskFeedback_GetResult_Request * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Request__fini(rai_interfaces__action__TaskFeedback_GetResult_Request * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_GetResult_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_GetResult_Request *
rai_interfaces__action__TaskFeedback_GetResult_Request__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_GetResult_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Request__destroy(rai_interfaces__action__TaskFeedback_GetResult_Request * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Request__are_equal(const rai_interfaces__action__TaskFeedback_GetResult_Request * lhs, const rai_interfaces__action__TaskFeedback_GetResult_Request * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Request__copy(
  const rai_interfaces__action__TaskFeedback_GetResult_Request * input,
  rai_interfaces__action__TaskFeedback_GetResult_Request * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_GetResult_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__init(rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_GetResult_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__fini(rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence *
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__destroy(rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * lhs, const rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * input,
  rai_interfaces__action__TaskFeedback_GetResult_Request__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_GetResult_Response
 * )) before or use
 * rai_interfaces__action__TaskFeedback_GetResult_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Response__init(rai_interfaces__action__TaskFeedback_GetResult_Response * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Response__fini(rai_interfaces__action__TaskFeedback_GetResult_Response * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_GetResult_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_GetResult_Response *
rai_interfaces__action__TaskFeedback_GetResult_Response__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_GetResult_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Response__destroy(rai_interfaces__action__TaskFeedback_GetResult_Response * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Response__are_equal(const rai_interfaces__action__TaskFeedback_GetResult_Response * lhs, const rai_interfaces__action__TaskFeedback_GetResult_Response * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Response__copy(
  const rai_interfaces__action__TaskFeedback_GetResult_Response * input,
  rai_interfaces__action__TaskFeedback_GetResult_Response * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_GetResult_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__init(rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_GetResult_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__fini(rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence *
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__destroy(rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * lhs, const rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * input,
  rai_interfaces__action__TaskFeedback_GetResult_Response__Sequence * output);

/// Initialize action/TaskFeedback message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rai_interfaces__action__TaskFeedback_FeedbackMessage
 * )) before or use
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_FeedbackMessage__init(rai_interfaces__action__TaskFeedback_FeedbackMessage * msg);

/// Finalize action/TaskFeedback message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_FeedbackMessage__fini(rai_interfaces__action__TaskFeedback_FeedbackMessage * msg);

/// Create action/TaskFeedback message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_FeedbackMessage *
rai_interfaces__action__TaskFeedback_FeedbackMessage__create();

/// Destroy action/TaskFeedback message.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_FeedbackMessage__destroy(rai_interfaces__action__TaskFeedback_FeedbackMessage * msg);

/// Check for action/TaskFeedback message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_FeedbackMessage__are_equal(const rai_interfaces__action__TaskFeedback_FeedbackMessage * lhs, const rai_interfaces__action__TaskFeedback_FeedbackMessage * rhs);

/// Copy a action/TaskFeedback message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_FeedbackMessage__copy(
  const rai_interfaces__action__TaskFeedback_FeedbackMessage * input,
  rai_interfaces__action__TaskFeedback_FeedbackMessage * output);

/// Initialize array of action/TaskFeedback messages.
/**
 * It allocates the memory for the number of elements and calls
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__init(rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * array, size_t size);

/// Finalize array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__fini(rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * array);

/// Create array of action/TaskFeedback messages.
/**
 * It allocates the memory for the array and calls
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence *
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__create(size_t size);

/// Destroy array of action/TaskFeedback messages.
/**
 * It calls
 * rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
void
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__destroy(rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * array);

/// Check for action/TaskFeedback message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__are_equal(const rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * lhs, const rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * rhs);

/// Copy an array of action/TaskFeedback messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rai_interfaces
bool
rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence__copy(
  const rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * input,
  rai_interfaces__action__TaskFeedback_FeedbackMessage__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__ACTION__DETAIL__TASK_FEEDBACK__FUNCTIONS_H_
