// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rai_interfaces:msg/AudioMessage.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rai_interfaces/msg/detail/audio_message__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rai_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void AudioMessage_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rai_interfaces::msg::AudioMessage(_init);
}

void AudioMessage_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rai_interfaces::msg::AudioMessage *>(message_memory);
  typed_message->~AudioMessage();
}

size_t size_function__AudioMessage__audio(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<int16_t> *>(untyped_member);
  return member->size();
}

const void * get_const_function__AudioMessage__audio(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<int16_t> *>(untyped_member);
  return &member[index];
}

void * get_function__AudioMessage__audio(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<int16_t> *>(untyped_member);
  return &member[index];
}

void fetch_function__AudioMessage__audio(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const int16_t *>(
    get_const_function__AudioMessage__audio(untyped_member, index));
  auto & value = *reinterpret_cast<int16_t *>(untyped_value);
  value = item;
}

void assign_function__AudioMessage__audio(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<int16_t *>(
    get_function__AudioMessage__audio(untyped_member, index));
  const auto & value = *reinterpret_cast<const int16_t *>(untyped_value);
  item = value;
}

void resize_function__AudioMessage__audio(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<int16_t> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember AudioMessage_message_member_array[3] = {
  {
    "audio",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::AudioMessage, audio),  // bytes offset in struct
    nullptr,  // default value
    size_function__AudioMessage__audio,  // size() function pointer
    get_const_function__AudioMessage__audio,  // get_const(index) function pointer
    get_function__AudioMessage__audio,  // get(index) function pointer
    fetch_function__AudioMessage__audio,  // fetch(index, &value) function pointer
    assign_function__AudioMessage__audio,  // assign(index, value) function pointer
    resize_function__AudioMessage__audio  // resize(index) function pointer
  },
  {
    "sample_rate",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::AudioMessage, sample_rate),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "channels",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rai_interfaces::msg::AudioMessage, channels),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers AudioMessage_message_members = {
  "rai_interfaces::msg",  // message namespace
  "AudioMessage",  // message name
  3,  // number of fields
  sizeof(rai_interfaces::msg::AudioMessage),
  AudioMessage_message_member_array,  // message members
  AudioMessage_init_function,  // function to initialize message memory (memory has to be allocated)
  AudioMessage_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t AudioMessage_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &AudioMessage_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace rai_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rai_interfaces::msg::AudioMessage>()
{
  return &::rai_interfaces::msg::rosidl_typesupport_introspection_cpp::AudioMessage_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rai_interfaces, msg, AudioMessage)() {
  return &::rai_interfaces::msg::rosidl_typesupport_introspection_cpp::AudioMessage_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
