// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:msg/HRIMessage.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/msg/detail/hri_message__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `text`
// Member `communication_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `images`
#include "sensor_msgs/msg/detail/image__functions.h"
// Member `audios`
#include "rai_interfaces/msg/detail/audio_message__functions.h"

bool
rai_interfaces__msg__HRIMessage__init(rai_interfaces__msg__HRIMessage * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    rai_interfaces__msg__HRIMessage__fini(msg);
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__init(&msg->text)) {
    rai_interfaces__msg__HRIMessage__fini(msg);
    return false;
  }
  // images
  if (!sensor_msgs__msg__Image__Sequence__init(&msg->images, 0)) {
    rai_interfaces__msg__HRIMessage__fini(msg);
    return false;
  }
  // audios
  if (!rai_interfaces__msg__AudioMessage__Sequence__init(&msg->audios, 0)) {
    rai_interfaces__msg__HRIMessage__fini(msg);
    return false;
  }
  // communication_id
  if (!rosidl_runtime_c__String__init(&msg->communication_id)) {
    rai_interfaces__msg__HRIMessage__fini(msg);
    return false;
  }
  // seq_no
  // seq_end
  return true;
}

void
rai_interfaces__msg__HRIMessage__fini(rai_interfaces__msg__HRIMessage * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // text
  rosidl_runtime_c__String__fini(&msg->text);
  // images
  sensor_msgs__msg__Image__Sequence__fini(&msg->images);
  // audios
  rai_interfaces__msg__AudioMessage__Sequence__fini(&msg->audios);
  // communication_id
  rosidl_runtime_c__String__fini(&msg->communication_id);
  // seq_no
  // seq_end
}

bool
rai_interfaces__msg__HRIMessage__are_equal(const rai_interfaces__msg__HRIMessage * lhs, const rai_interfaces__msg__HRIMessage * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->text), &(rhs->text)))
  {
    return false;
  }
  // images
  if (!sensor_msgs__msg__Image__Sequence__are_equal(
      &(lhs->images), &(rhs->images)))
  {
    return false;
  }
  // audios
  if (!rai_interfaces__msg__AudioMessage__Sequence__are_equal(
      &(lhs->audios), &(rhs->audios)))
  {
    return false;
  }
  // communication_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->communication_id), &(rhs->communication_id)))
  {
    return false;
  }
  // seq_no
  if (lhs->seq_no != rhs->seq_no) {
    return false;
  }
  // seq_end
  if (lhs->seq_end != rhs->seq_end) {
    return false;
  }
  return true;
}

bool
rai_interfaces__msg__HRIMessage__copy(
  const rai_interfaces__msg__HRIMessage * input,
  rai_interfaces__msg__HRIMessage * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // text
  if (!rosidl_runtime_c__String__copy(
      &(input->text), &(output->text)))
  {
    return false;
  }
  // images
  if (!sensor_msgs__msg__Image__Sequence__copy(
      &(input->images), &(output->images)))
  {
    return false;
  }
  // audios
  if (!rai_interfaces__msg__AudioMessage__Sequence__copy(
      &(input->audios), &(output->audios)))
  {
    return false;
  }
  // communication_id
  if (!rosidl_runtime_c__String__copy(
      &(input->communication_id), &(output->communication_id)))
  {
    return false;
  }
  // seq_no
  output->seq_no = input->seq_no;
  // seq_end
  output->seq_end = input->seq_end;
  return true;
}

rai_interfaces__msg__HRIMessage *
rai_interfaces__msg__HRIMessage__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__HRIMessage * msg = (rai_interfaces__msg__HRIMessage *)allocator.allocate(sizeof(rai_interfaces__msg__HRIMessage), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__msg__HRIMessage));
  bool success = rai_interfaces__msg__HRIMessage__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__msg__HRIMessage__destroy(rai_interfaces__msg__HRIMessage * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__msg__HRIMessage__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__msg__HRIMessage__Sequence__init(rai_interfaces__msg__HRIMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__HRIMessage * data = NULL;

  if (size) {
    data = (rai_interfaces__msg__HRIMessage *)allocator.zero_allocate(size, sizeof(rai_interfaces__msg__HRIMessage), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__msg__HRIMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__msg__HRIMessage__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__msg__HRIMessage__Sequence__fini(rai_interfaces__msg__HRIMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__msg__HRIMessage__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__msg__HRIMessage__Sequence *
rai_interfaces__msg__HRIMessage__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__HRIMessage__Sequence * array = (rai_interfaces__msg__HRIMessage__Sequence *)allocator.allocate(sizeof(rai_interfaces__msg__HRIMessage__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__msg__HRIMessage__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__msg__HRIMessage__Sequence__destroy(rai_interfaces__msg__HRIMessage__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__msg__HRIMessage__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__msg__HRIMessage__Sequence__are_equal(const rai_interfaces__msg__HRIMessage__Sequence * lhs, const rai_interfaces__msg__HRIMessage__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__msg__HRIMessage__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__msg__HRIMessage__Sequence__copy(
  const rai_interfaces__msg__HRIMessage__Sequence * input,
  rai_interfaces__msg__HRIMessage__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__msg__HRIMessage);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__msg__HRIMessage * data =
      (rai_interfaces__msg__HRIMessage *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__msg__HRIMessage__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__msg__HRIMessage__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__msg__HRIMessage__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
