// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rai_interfaces:msg/HRIMessage.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__STRUCT_H_
#define RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'text'
// Member 'communication_id'
#include "rosidl_runtime_c/string.h"
// Member 'images'
#include "sensor_msgs/msg/detail/image__struct.h"
// Member 'audios'
#include "rai_interfaces/msg/detail/audio_message__struct.h"

/// Struct defined in msg/HRIMessage in the package rai_interfaces.
/**
  * Copyright (C) 2024 Robotec.AI
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
  *  You may obtain a copy of the License at
  *
  *          http://www.apache.org/licenses/LICENSE-2.0
  *
  *  Unless required by applicable law or agreed to in writing, software
  *  distributed under the License is distributed on an "AS IS" BASIS,
  *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  *  See the License for the specific language governing permissions and
  *  limitations under the License.
 */
typedef struct rai_interfaces__msg__HRIMessage
{
  std_msgs__msg__Header header;
  rosidl_runtime_c__String text;
  sensor_msgs__msg__Image__Sequence images;
  rai_interfaces__msg__AudioMessage__Sequence audios;
  rosidl_runtime_c__String communication_id;
  int64_t seq_no;
  bool seq_end;
} rai_interfaces__msg__HRIMessage;

// Struct for a sequence of rai_interfaces__msg__HRIMessage.
typedef struct rai_interfaces__msg__HRIMessage__Sequence
{
  rai_interfaces__msg__HRIMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__msg__HRIMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__MSG__DETAIL__HRI_MESSAGE__STRUCT_H_
