// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:msg/RAIDetectionArray.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/msg/detail/rai_detection_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `detections`
#include "vision_msgs/msg/detail/detection2_d__functions.h"
// Member `detection_classes`
#include "rosidl_runtime_c/string_functions.h"

bool
rai_interfaces__msg__RAIDetectionArray__init(rai_interfaces__msg__RAIDetectionArray * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    rai_interfaces__msg__RAIDetectionArray__fini(msg);
    return false;
  }
  // detections
  if (!vision_msgs__msg__Detection2D__Sequence__init(&msg->detections, 0)) {
    rai_interfaces__msg__RAIDetectionArray__fini(msg);
    return false;
  }
  // detection_classes
  if (!rosidl_runtime_c__String__Sequence__init(&msg->detection_classes, 0)) {
    rai_interfaces__msg__RAIDetectionArray__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__msg__RAIDetectionArray__fini(rai_interfaces__msg__RAIDetectionArray * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // detections
  vision_msgs__msg__Detection2D__Sequence__fini(&msg->detections);
  // detection_classes
  rosidl_runtime_c__String__Sequence__fini(&msg->detection_classes);
}

bool
rai_interfaces__msg__RAIDetectionArray__are_equal(const rai_interfaces__msg__RAIDetectionArray * lhs, const rai_interfaces__msg__RAIDetectionArray * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // detections
  if (!vision_msgs__msg__Detection2D__Sequence__are_equal(
      &(lhs->detections), &(rhs->detections)))
  {
    return false;
  }
  // detection_classes
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->detection_classes), &(rhs->detection_classes)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__msg__RAIDetectionArray__copy(
  const rai_interfaces__msg__RAIDetectionArray * input,
  rai_interfaces__msg__RAIDetectionArray * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // detections
  if (!vision_msgs__msg__Detection2D__Sequence__copy(
      &(input->detections), &(output->detections)))
  {
    return false;
  }
  // detection_classes
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->detection_classes), &(output->detection_classes)))
  {
    return false;
  }
  return true;
}

rai_interfaces__msg__RAIDetectionArray *
rai_interfaces__msg__RAIDetectionArray__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__RAIDetectionArray * msg = (rai_interfaces__msg__RAIDetectionArray *)allocator.allocate(sizeof(rai_interfaces__msg__RAIDetectionArray), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__msg__RAIDetectionArray));
  bool success = rai_interfaces__msg__RAIDetectionArray__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__msg__RAIDetectionArray__destroy(rai_interfaces__msg__RAIDetectionArray * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__msg__RAIDetectionArray__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__msg__RAIDetectionArray__Sequence__init(rai_interfaces__msg__RAIDetectionArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__RAIDetectionArray * data = NULL;

  if (size) {
    data = (rai_interfaces__msg__RAIDetectionArray *)allocator.zero_allocate(size, sizeof(rai_interfaces__msg__RAIDetectionArray), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__msg__RAIDetectionArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__msg__RAIDetectionArray__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__msg__RAIDetectionArray__Sequence__fini(rai_interfaces__msg__RAIDetectionArray__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__msg__RAIDetectionArray__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__msg__RAIDetectionArray__Sequence *
rai_interfaces__msg__RAIDetectionArray__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__msg__RAIDetectionArray__Sequence * array = (rai_interfaces__msg__RAIDetectionArray__Sequence *)allocator.allocate(sizeof(rai_interfaces__msg__RAIDetectionArray__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__msg__RAIDetectionArray__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__msg__RAIDetectionArray__Sequence__destroy(rai_interfaces__msg__RAIDetectionArray__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__msg__RAIDetectionArray__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__msg__RAIDetectionArray__Sequence__are_equal(const rai_interfaces__msg__RAIDetectionArray__Sequence * lhs, const rai_interfaces__msg__RAIDetectionArray__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__msg__RAIDetectionArray__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__msg__RAIDetectionArray__Sequence__copy(
  const rai_interfaces__msg__RAIDetectionArray__Sequence * input,
  rai_interfaces__msg__RAIDetectionArray__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__msg__RAIDetectionArray);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__msg__RAIDetectionArray * data =
      (rai_interfaces__msg__RAIDetectionArray *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__msg__RAIDetectionArray__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__msg__RAIDetectionArray__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__msg__RAIDetectionArray__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
