// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rai_interfaces:msg/RAIDetectionArray.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__STRUCT_H_
#define RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'detections'
#include "vision_msgs/msg/detail/detection2_d__struct.h"
// Member 'detection_classes'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/RAIDetectionArray in the package rai_interfaces.
/**
  * Copyright (C) 2024 Robotec.AI
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
  *  You may obtain a copy of the License at
  *
  *          http://www.apache.org/licenses/LICENSE-2.0
  *
  *  Unless required by applicable law or agreed to in writing, software
  *  distributed under the License is distributed on an "AS IS" BASIS,
  *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  *  See the License for the specific language governing permissions and
  *  limitations under the License.
 */
typedef struct rai_interfaces__msg__RAIDetectionArray
{
  /// A list of 2D detections, for a multi-object 2D detector.
  std_msgs__msg__Header header;
  /// A list of the detected proposals. A multi-proposal detector might generate
  ///   this list with many candidate detections generated from a single input.
  vision_msgs__msg__Detection2D__Sequence detections;
  /// a list of classes being detected
  rosidl_runtime_c__String__Sequence detection_classes;
} rai_interfaces__msg__RAIDetectionArray;

// Struct for a sequence of rai_interfaces__msg__RAIDetectionArray.
typedef struct rai_interfaces__msg__RAIDetectionArray__Sequence
{
  rai_interfaces__msg__RAIDetectionArray * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__msg__RAIDetectionArray__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__STRUCT_H_
