// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:msg/RAIDetectionArray.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__STRUCT_HPP_
#define RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'detections'
#include "vision_msgs/msg/detail/detection2_d__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__msg__RAIDetectionArray __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__msg__RAIDetectionArray __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RAIDetectionArray_
{
  using Type = RAIDetectionArray_<ContainerAllocator>;

  explicit RAIDetectionArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit RAIDetectionArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _detections_type =
    std::vector<vision_msgs::msg::Detection2D_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<vision_msgs::msg::Detection2D_<ContainerAllocator>>>;
  _detections_type detections;
  using _detection_classes_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _detection_classes_type detection_classes;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__detections(
    const std::vector<vision_msgs::msg::Detection2D_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<vision_msgs::msg::Detection2D_<ContainerAllocator>>> & _arg)
  {
    this->detections = _arg;
    return *this;
  }
  Type & set__detection_classes(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->detection_classes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__msg__RAIDetectionArray
    std::shared_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__msg__RAIDetectionArray
    std::shared_ptr<rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RAIDetectionArray_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->detections != other.detections) {
      return false;
    }
    if (this->detection_classes != other.detection_classes) {
      return false;
    }
    return true;
  }
  bool operator!=(const RAIDetectionArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RAIDetectionArray_

// alias to use template instance with default allocator
using RAIDetectionArray =
  rai_interfaces::msg::RAIDetectionArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__MSG__DETAIL__RAI_DETECTION_ARRAY__STRUCT_HPP_
