// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:srv/RAIGroundedSam.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/srv/detail/rai_grounded_sam__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `detections`
#include "rai_interfaces/msg/detail/rai_detection_array__functions.h"
// Member `source_img`
#include "sensor_msgs/msg/detail/image__functions.h"

bool
rai_interfaces__srv__RAIGroundedSam_Request__init(rai_interfaces__srv__RAIGroundedSam_Request * msg)
{
  if (!msg) {
    return false;
  }
  // detections
  if (!rai_interfaces__msg__RAIDetectionArray__init(&msg->detections)) {
    rai_interfaces__srv__RAIGroundedSam_Request__fini(msg);
    return false;
  }
  // source_img
  if (!sensor_msgs__msg__Image__init(&msg->source_img)) {
    rai_interfaces__srv__RAIGroundedSam_Request__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__RAIGroundedSam_Request__fini(rai_interfaces__srv__RAIGroundedSam_Request * msg)
{
  if (!msg) {
    return;
  }
  // detections
  rai_interfaces__msg__RAIDetectionArray__fini(&msg->detections);
  // source_img
  sensor_msgs__msg__Image__fini(&msg->source_img);
}

bool
rai_interfaces__srv__RAIGroundedSam_Request__are_equal(const rai_interfaces__srv__RAIGroundedSam_Request * lhs, const rai_interfaces__srv__RAIGroundedSam_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // detections
  if (!rai_interfaces__msg__RAIDetectionArray__are_equal(
      &(lhs->detections), &(rhs->detections)))
  {
    return false;
  }
  // source_img
  if (!sensor_msgs__msg__Image__are_equal(
      &(lhs->source_img), &(rhs->source_img)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__RAIGroundedSam_Request__copy(
  const rai_interfaces__srv__RAIGroundedSam_Request * input,
  rai_interfaces__srv__RAIGroundedSam_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // detections
  if (!rai_interfaces__msg__RAIDetectionArray__copy(
      &(input->detections), &(output->detections)))
  {
    return false;
  }
  // source_img
  if (!sensor_msgs__msg__Image__copy(
      &(input->source_img), &(output->source_img)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__RAIGroundedSam_Request *
rai_interfaces__srv__RAIGroundedSam_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__RAIGroundedSam_Request * msg = (rai_interfaces__srv__RAIGroundedSam_Request *)allocator.allocate(sizeof(rai_interfaces__srv__RAIGroundedSam_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__RAIGroundedSam_Request));
  bool success = rai_interfaces__srv__RAIGroundedSam_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__RAIGroundedSam_Request__destroy(rai_interfaces__srv__RAIGroundedSam_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__RAIGroundedSam_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__RAIGroundedSam_Request__Sequence__init(rai_interfaces__srv__RAIGroundedSam_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__RAIGroundedSam_Request * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__RAIGroundedSam_Request *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__RAIGroundedSam_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__RAIGroundedSam_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__RAIGroundedSam_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__RAIGroundedSam_Request__Sequence__fini(rai_interfaces__srv__RAIGroundedSam_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__RAIGroundedSam_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__RAIGroundedSam_Request__Sequence *
rai_interfaces__srv__RAIGroundedSam_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__RAIGroundedSam_Request__Sequence * array = (rai_interfaces__srv__RAIGroundedSam_Request__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__RAIGroundedSam_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__RAIGroundedSam_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__RAIGroundedSam_Request__Sequence__destroy(rai_interfaces__srv__RAIGroundedSam_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__RAIGroundedSam_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__RAIGroundedSam_Request__Sequence__are_equal(const rai_interfaces__srv__RAIGroundedSam_Request__Sequence * lhs, const rai_interfaces__srv__RAIGroundedSam_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__RAIGroundedSam_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__RAIGroundedSam_Request__Sequence__copy(
  const rai_interfaces__srv__RAIGroundedSam_Request__Sequence * input,
  rai_interfaces__srv__RAIGroundedSam_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__RAIGroundedSam_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__RAIGroundedSam_Request * data =
      (rai_interfaces__srv__RAIGroundedSam_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__RAIGroundedSam_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__RAIGroundedSam_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__RAIGroundedSam_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `masks`
// already included above
// #include "sensor_msgs/msg/detail/image__functions.h"

bool
rai_interfaces__srv__RAIGroundedSam_Response__init(rai_interfaces__srv__RAIGroundedSam_Response * msg)
{
  if (!msg) {
    return false;
  }
  // masks
  if (!sensor_msgs__msg__Image__Sequence__init(&msg->masks, 0)) {
    rai_interfaces__srv__RAIGroundedSam_Response__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__RAIGroundedSam_Response__fini(rai_interfaces__srv__RAIGroundedSam_Response * msg)
{
  if (!msg) {
    return;
  }
  // masks
  sensor_msgs__msg__Image__Sequence__fini(&msg->masks);
}

bool
rai_interfaces__srv__RAIGroundedSam_Response__are_equal(const rai_interfaces__srv__RAIGroundedSam_Response * lhs, const rai_interfaces__srv__RAIGroundedSam_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // masks
  if (!sensor_msgs__msg__Image__Sequence__are_equal(
      &(lhs->masks), &(rhs->masks)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__RAIGroundedSam_Response__copy(
  const rai_interfaces__srv__RAIGroundedSam_Response * input,
  rai_interfaces__srv__RAIGroundedSam_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // masks
  if (!sensor_msgs__msg__Image__Sequence__copy(
      &(input->masks), &(output->masks)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__RAIGroundedSam_Response *
rai_interfaces__srv__RAIGroundedSam_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__RAIGroundedSam_Response * msg = (rai_interfaces__srv__RAIGroundedSam_Response *)allocator.allocate(sizeof(rai_interfaces__srv__RAIGroundedSam_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__RAIGroundedSam_Response));
  bool success = rai_interfaces__srv__RAIGroundedSam_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__RAIGroundedSam_Response__destroy(rai_interfaces__srv__RAIGroundedSam_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__RAIGroundedSam_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__RAIGroundedSam_Response__Sequence__init(rai_interfaces__srv__RAIGroundedSam_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__RAIGroundedSam_Response * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__RAIGroundedSam_Response *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__RAIGroundedSam_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__RAIGroundedSam_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__RAIGroundedSam_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__RAIGroundedSam_Response__Sequence__fini(rai_interfaces__srv__RAIGroundedSam_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__RAIGroundedSam_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__RAIGroundedSam_Response__Sequence *
rai_interfaces__srv__RAIGroundedSam_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__RAIGroundedSam_Response__Sequence * array = (rai_interfaces__srv__RAIGroundedSam_Response__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__RAIGroundedSam_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__RAIGroundedSam_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__RAIGroundedSam_Response__Sequence__destroy(rai_interfaces__srv__RAIGroundedSam_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__RAIGroundedSam_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__RAIGroundedSam_Response__Sequence__are_equal(const rai_interfaces__srv__RAIGroundedSam_Response__Sequence * lhs, const rai_interfaces__srv__RAIGroundedSam_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__RAIGroundedSam_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__RAIGroundedSam_Response__Sequence__copy(
  const rai_interfaces__srv__RAIGroundedSam_Response__Sequence * input,
  rai_interfaces__srv__RAIGroundedSam_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__RAIGroundedSam_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__RAIGroundedSam_Response * data =
      (rai_interfaces__srv__RAIGroundedSam_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__RAIGroundedSam_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__RAIGroundedSam_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__RAIGroundedSam_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
