// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/RAIGroundedSam.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDED_SAM__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDED_SAM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/rai_grounded_sam__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'detections'
#include "rai_interfaces/msg/detail/rai_detection_array__traits.hpp"
// Member 'source_img'
#include "sensor_msgs/msg/detail/image__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const RAIGroundedSam_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: detections
  {
    out << "detections: ";
    to_flow_style_yaml(msg.detections, out);
    out << ", ";
  }

  // member: source_img
  {
    out << "source_img: ";
    to_flow_style_yaml(msg.source_img, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RAIGroundedSam_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: detections
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detections:\n";
    to_block_style_yaml(msg.detections, out, indentation + 2);
  }

  // member: source_img
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "source_img:\n";
    to_block_style_yaml(msg.source_img, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RAIGroundedSam_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::RAIGroundedSam_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::RAIGroundedSam_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::RAIGroundedSam_Request>()
{
  return "rai_interfaces::srv::RAIGroundedSam_Request";
}

template<>
inline const char * name<rai_interfaces::srv::RAIGroundedSam_Request>()
{
  return "rai_interfaces/srv/RAIGroundedSam_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::RAIGroundedSam_Request>
  : std::integral_constant<bool, has_fixed_size<rai_interfaces::msg::RAIDetectionArray>::value && has_fixed_size<sensor_msgs::msg::Image>::value> {};

template<>
struct has_bounded_size<rai_interfaces::srv::RAIGroundedSam_Request>
  : std::integral_constant<bool, has_bounded_size<rai_interfaces::msg::RAIDetectionArray>::value && has_bounded_size<sensor_msgs::msg::Image>::value> {};

template<>
struct is_message<rai_interfaces::srv::RAIGroundedSam_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'masks'
// already included above
// #include "sensor_msgs/msg/detail/image__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const RAIGroundedSam_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: masks
  {
    if (msg.masks.size() == 0) {
      out << "masks: []";
    } else {
      out << "masks: [";
      size_t pending_items = msg.masks.size();
      for (auto item : msg.masks) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RAIGroundedSam_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: masks
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.masks.size() == 0) {
      out << "masks: []\n";
    } else {
      out << "masks:\n";
      for (auto item : msg.masks) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RAIGroundedSam_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::RAIGroundedSam_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::RAIGroundedSam_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::RAIGroundedSam_Response>()
{
  return "rai_interfaces::srv::RAIGroundedSam_Response";
}

template<>
inline const char * name<rai_interfaces::srv::RAIGroundedSam_Response>()
{
  return "rai_interfaces/srv/RAIGroundedSam_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::RAIGroundedSam_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::RAIGroundedSam_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::RAIGroundedSam_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::RAIGroundedSam>()
{
  return "rai_interfaces::srv::RAIGroundedSam";
}

template<>
inline const char * name<rai_interfaces::srv::RAIGroundedSam>()
{
  return "rai_interfaces/srv/RAIGroundedSam";
}

template<>
struct has_fixed_size<rai_interfaces::srv::RAIGroundedSam>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::RAIGroundedSam_Request>::value &&
    has_fixed_size<rai_interfaces::srv::RAIGroundedSam_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::RAIGroundedSam>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::RAIGroundedSam_Request>::value &&
    has_bounded_size<rai_interfaces::srv::RAIGroundedSam_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::RAIGroundedSam>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::RAIGroundedSam_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::RAIGroundedSam_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDED_SAM__TRAITS_HPP_
