// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:srv/RAIGroundingDino.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDING_DINO__STRUCT_HPP_
#define RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDING_DINO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'source_img'
#include "sensor_msgs/msg/detail/image__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Request __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Request __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RAIGroundingDino_Request_
{
  using Type = RAIGroundingDino_Request_<ContainerAllocator>;

  explicit RAIGroundingDino_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : source_img(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->classes = "";
      this->box_threshold = 0.0;
      this->text_threshold = 0.0;
    }
  }

  explicit RAIGroundingDino_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : classes(_alloc),
    source_img(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->classes = "";
      this->box_threshold = 0.0;
      this->text_threshold = 0.0;
    }
  }

  // field types and members
  using _classes_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _classes_type classes;
  using _box_threshold_type =
    double;
  _box_threshold_type box_threshold;
  using _text_threshold_type =
    double;
  _text_threshold_type text_threshold;
  using _source_img_type =
    sensor_msgs::msg::Image_<ContainerAllocator>;
  _source_img_type source_img;

  // setters for named parameter idiom
  Type & set__classes(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->classes = _arg;
    return *this;
  }
  Type & set__box_threshold(
    const double & _arg)
  {
    this->box_threshold = _arg;
    return *this;
  }
  Type & set__text_threshold(
    const double & _arg)
  {
    this->text_threshold = _arg;
    return *this;
  }
  Type & set__source_img(
    const sensor_msgs::msg::Image_<ContainerAllocator> & _arg)
  {
    this->source_img = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Request
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Request
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RAIGroundingDino_Request_ & other) const
  {
    if (this->classes != other.classes) {
      return false;
    }
    if (this->box_threshold != other.box_threshold) {
      return false;
    }
    if (this->text_threshold != other.text_threshold) {
      return false;
    }
    if (this->source_img != other.source_img) {
      return false;
    }
    return true;
  }
  bool operator!=(const RAIGroundingDino_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RAIGroundingDino_Request_

// alias to use template instance with default allocator
using RAIGroundingDino_Request =
  rai_interfaces::srv::RAIGroundingDino_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


// Include directives for member types
// Member 'detections'
#include "rai_interfaces/msg/detail/rai_detection_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Response __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Response __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RAIGroundingDino_Response_
{
  using Type = RAIGroundingDino_Response_<ContainerAllocator>;

  explicit RAIGroundingDino_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : detections(_init)
  {
    (void)_init;
  }

  explicit RAIGroundingDino_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : detections(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _detections_type =
    rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator>;
  _detections_type detections;

  // setters for named parameter idiom
  Type & set__detections(
    const rai_interfaces::msg::RAIDetectionArray_<ContainerAllocator> & _arg)
  {
    this->detections = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Response
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__RAIGroundingDino_Response
    std::shared_ptr<rai_interfaces::srv::RAIGroundingDino_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RAIGroundingDino_Response_ & other) const
  {
    if (this->detections != other.detections) {
      return false;
    }
    return true;
  }
  bool operator!=(const RAIGroundingDino_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RAIGroundingDino_Response_

// alias to use template instance with default allocator
using RAIGroundingDino_Response =
  rai_interfaces::srv::RAIGroundingDino_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces

namespace rai_interfaces
{

namespace srv
{

struct RAIGroundingDino
{
  using Request = rai_interfaces::srv::RAIGroundingDino_Request;
  using Response = rai_interfaces::srv::RAIGroundingDino_Response;
};

}  // namespace srv

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDING_DINO__STRUCT_HPP_
