// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/RAIGroundingDino.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDING_DINO__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDING_DINO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/rai_grounding_dino__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'source_img'
#include "sensor_msgs/msg/detail/image__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const RAIGroundingDino_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: classes
  {
    out << "classes: ";
    rosidl_generator_traits::value_to_yaml(msg.classes, out);
    out << ", ";
  }

  // member: box_threshold
  {
    out << "box_threshold: ";
    rosidl_generator_traits::value_to_yaml(msg.box_threshold, out);
    out << ", ";
  }

  // member: text_threshold
  {
    out << "text_threshold: ";
    rosidl_generator_traits::value_to_yaml(msg.text_threshold, out);
    out << ", ";
  }

  // member: source_img
  {
    out << "source_img: ";
    to_flow_style_yaml(msg.source_img, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RAIGroundingDino_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: classes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "classes: ";
    rosidl_generator_traits::value_to_yaml(msg.classes, out);
    out << "\n";
  }

  // member: box_threshold
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "box_threshold: ";
    rosidl_generator_traits::value_to_yaml(msg.box_threshold, out);
    out << "\n";
  }

  // member: text_threshold
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "text_threshold: ";
    rosidl_generator_traits::value_to_yaml(msg.text_threshold, out);
    out << "\n";
  }

  // member: source_img
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "source_img:\n";
    to_block_style_yaml(msg.source_img, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RAIGroundingDino_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::RAIGroundingDino_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::RAIGroundingDino_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::RAIGroundingDino_Request>()
{
  return "rai_interfaces::srv::RAIGroundingDino_Request";
}

template<>
inline const char * name<rai_interfaces::srv::RAIGroundingDino_Request>()
{
  return "rai_interfaces/srv/RAIGroundingDino_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::RAIGroundingDino_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::RAIGroundingDino_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::RAIGroundingDino_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'detections'
#include "rai_interfaces/msg/detail/rai_detection_array__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const RAIGroundingDino_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: detections
  {
    out << "detections: ";
    to_flow_style_yaml(msg.detections, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RAIGroundingDino_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: detections
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detections:\n";
    to_block_style_yaml(msg.detections, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RAIGroundingDino_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::RAIGroundingDino_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::RAIGroundingDino_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::RAIGroundingDino_Response>()
{
  return "rai_interfaces::srv::RAIGroundingDino_Response";
}

template<>
inline const char * name<rai_interfaces::srv::RAIGroundingDino_Response>()
{
  return "rai_interfaces/srv/RAIGroundingDino_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::RAIGroundingDino_Response>
  : std::integral_constant<bool, has_fixed_size<rai_interfaces::msg::RAIDetectionArray>::value> {};

template<>
struct has_bounded_size<rai_interfaces::srv::RAIGroundingDino_Response>
  : std::integral_constant<bool, has_bounded_size<rai_interfaces::msg::RAIDetectionArray>::value> {};

template<>
struct is_message<rai_interfaces::srv::RAIGroundingDino_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::RAIGroundingDino>()
{
  return "rai_interfaces::srv::RAIGroundingDino";
}

template<>
inline const char * name<rai_interfaces::srv::RAIGroundingDino>()
{
  return "rai_interfaces/srv/RAIGroundingDino";
}

template<>
struct has_fixed_size<rai_interfaces::srv::RAIGroundingDino>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::RAIGroundingDino_Request>::value &&
    has_fixed_size<rai_interfaces::srv::RAIGroundingDino_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::RAIGroundingDino>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::RAIGroundingDino_Request>::value &&
    has_bounded_size<rai_interfaces::srv::RAIGroundingDino_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::RAIGroundingDino>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::RAIGroundingDino_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::RAIGroundingDino_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__RAI_GROUNDING_DINO__TRAITS_HPP_
