// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:srv/VectorStoreRetrieval.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/srv/detail/vector_store_retrieval__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `query`
#include "rosidl_runtime_c/string_functions.h"

bool
rai_interfaces__srv__VectorStoreRetrieval_Request__init(rai_interfaces__srv__VectorStoreRetrieval_Request * msg)
{
  if (!msg) {
    return false;
  }
  // query
  if (!rosidl_runtime_c__String__init(&msg->query)) {
    rai_interfaces__srv__VectorStoreRetrieval_Request__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Request__fini(rai_interfaces__srv__VectorStoreRetrieval_Request * msg)
{
  if (!msg) {
    return;
  }
  // query
  rosidl_runtime_c__String__fini(&msg->query);
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Request__are_equal(const rai_interfaces__srv__VectorStoreRetrieval_Request * lhs, const rai_interfaces__srv__VectorStoreRetrieval_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // query
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->query), &(rhs->query)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Request__copy(
  const rai_interfaces__srv__VectorStoreRetrieval_Request * input,
  rai_interfaces__srv__VectorStoreRetrieval_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // query
  if (!rosidl_runtime_c__String__copy(
      &(input->query), &(output->query)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__VectorStoreRetrieval_Request *
rai_interfaces__srv__VectorStoreRetrieval_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__VectorStoreRetrieval_Request * msg = (rai_interfaces__srv__VectorStoreRetrieval_Request *)allocator.allocate(sizeof(rai_interfaces__srv__VectorStoreRetrieval_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__VectorStoreRetrieval_Request));
  bool success = rai_interfaces__srv__VectorStoreRetrieval_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Request__destroy(rai_interfaces__srv__VectorStoreRetrieval_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__VectorStoreRetrieval_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__init(rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__VectorStoreRetrieval_Request * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__VectorStoreRetrieval_Request *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__VectorStoreRetrieval_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__VectorStoreRetrieval_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__VectorStoreRetrieval_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__fini(rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__VectorStoreRetrieval_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence *
rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * array = (rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__destroy(rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__are_equal(const rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * lhs, const rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__VectorStoreRetrieval_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence__copy(
  const rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * input,
  rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__VectorStoreRetrieval_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__VectorStoreRetrieval_Request * data =
      (rai_interfaces__srv__VectorStoreRetrieval_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__VectorStoreRetrieval_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__VectorStoreRetrieval_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__VectorStoreRetrieval_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `message`
// Member `documents`
// already included above
// #include "rosidl_runtime_c/string_functions.h"
// Member `scores`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
rai_interfaces__srv__VectorStoreRetrieval_Response__init(rai_interfaces__srv__VectorStoreRetrieval_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    rai_interfaces__srv__VectorStoreRetrieval_Response__fini(msg);
    return false;
  }
  // documents
  if (!rosidl_runtime_c__String__Sequence__init(&msg->documents, 0)) {
    rai_interfaces__srv__VectorStoreRetrieval_Response__fini(msg);
    return false;
  }
  // scores
  if (!rosidl_runtime_c__float__Sequence__init(&msg->scores, 0)) {
    rai_interfaces__srv__VectorStoreRetrieval_Response__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Response__fini(rai_interfaces__srv__VectorStoreRetrieval_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // message
  rosidl_runtime_c__String__fini(&msg->message);
  // documents
  rosidl_runtime_c__String__Sequence__fini(&msg->documents);
  // scores
  rosidl_runtime_c__float__Sequence__fini(&msg->scores);
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Response__are_equal(const rai_interfaces__srv__VectorStoreRetrieval_Response * lhs, const rai_interfaces__srv__VectorStoreRetrieval_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message), &(rhs->message)))
  {
    return false;
  }
  // documents
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->documents), &(rhs->documents)))
  {
    return false;
  }
  // scores
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->scores), &(rhs->scores)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Response__copy(
  const rai_interfaces__srv__VectorStoreRetrieval_Response * input,
  rai_interfaces__srv__VectorStoreRetrieval_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // message
  if (!rosidl_runtime_c__String__copy(
      &(input->message), &(output->message)))
  {
    return false;
  }
  // documents
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->documents), &(output->documents)))
  {
    return false;
  }
  // scores
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->scores), &(output->scores)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__VectorStoreRetrieval_Response *
rai_interfaces__srv__VectorStoreRetrieval_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__VectorStoreRetrieval_Response * msg = (rai_interfaces__srv__VectorStoreRetrieval_Response *)allocator.allocate(sizeof(rai_interfaces__srv__VectorStoreRetrieval_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__VectorStoreRetrieval_Response));
  bool success = rai_interfaces__srv__VectorStoreRetrieval_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Response__destroy(rai_interfaces__srv__VectorStoreRetrieval_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__VectorStoreRetrieval_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__init(rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__VectorStoreRetrieval_Response * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__VectorStoreRetrieval_Response *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__VectorStoreRetrieval_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__VectorStoreRetrieval_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__VectorStoreRetrieval_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__fini(rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__VectorStoreRetrieval_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence *
rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * array = (rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__destroy(rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__are_equal(const rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * lhs, const rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__VectorStoreRetrieval_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence__copy(
  const rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * input,
  rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__VectorStoreRetrieval_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__VectorStoreRetrieval_Response * data =
      (rai_interfaces__srv__VectorStoreRetrieval_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__VectorStoreRetrieval_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__VectorStoreRetrieval_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__VectorStoreRetrieval_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
