// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:srv/WhatISee.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/srv/detail/what_i_see__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
rai_interfaces__srv__WhatISee_Request__init(rai_interfaces__srv__WhatISee_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
rai_interfaces__srv__WhatISee_Request__fini(rai_interfaces__srv__WhatISee_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
rai_interfaces__srv__WhatISee_Request__are_equal(const rai_interfaces__srv__WhatISee_Request * lhs, const rai_interfaces__srv__WhatISee_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__WhatISee_Request__copy(
  const rai_interfaces__srv__WhatISee_Request * input,
  rai_interfaces__srv__WhatISee_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

rai_interfaces__srv__WhatISee_Request *
rai_interfaces__srv__WhatISee_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__WhatISee_Request * msg = (rai_interfaces__srv__WhatISee_Request *)allocator.allocate(sizeof(rai_interfaces__srv__WhatISee_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__WhatISee_Request));
  bool success = rai_interfaces__srv__WhatISee_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__WhatISee_Request__destroy(rai_interfaces__srv__WhatISee_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__WhatISee_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__WhatISee_Request__Sequence__init(rai_interfaces__srv__WhatISee_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__WhatISee_Request * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__WhatISee_Request *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__WhatISee_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__WhatISee_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__WhatISee_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__WhatISee_Request__Sequence__fini(rai_interfaces__srv__WhatISee_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__WhatISee_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__WhatISee_Request__Sequence *
rai_interfaces__srv__WhatISee_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__WhatISee_Request__Sequence * array = (rai_interfaces__srv__WhatISee_Request__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__WhatISee_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__WhatISee_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__WhatISee_Request__Sequence__destroy(rai_interfaces__srv__WhatISee_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__WhatISee_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__WhatISee_Request__Sequence__are_equal(const rai_interfaces__srv__WhatISee_Request__Sequence * lhs, const rai_interfaces__srv__WhatISee_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__WhatISee_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__WhatISee_Request__Sequence__copy(
  const rai_interfaces__srv__WhatISee_Request__Sequence * input,
  rai_interfaces__srv__WhatISee_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__WhatISee_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__WhatISee_Request * data =
      (rai_interfaces__srv__WhatISee_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__WhatISee_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__WhatISee_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__WhatISee_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `observations`
// Member `perception_source`
#include "rosidl_runtime_c/string_functions.h"
// Member `image`
#include "sensor_msgs/msg/detail/image__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
rai_interfaces__srv__WhatISee_Response__init(rai_interfaces__srv__WhatISee_Response * msg)
{
  if (!msg) {
    return false;
  }
  // observations
  if (!rosidl_runtime_c__String__Sequence__init(&msg->observations, 0)) {
    rai_interfaces__srv__WhatISee_Response__fini(msg);
    return false;
  }
  // perception_source
  if (!rosidl_runtime_c__String__init(&msg->perception_source)) {
    rai_interfaces__srv__WhatISee_Response__fini(msg);
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__init(&msg->image)) {
    rai_interfaces__srv__WhatISee_Response__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    rai_interfaces__srv__WhatISee_Response__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__WhatISee_Response__fini(rai_interfaces__srv__WhatISee_Response * msg)
{
  if (!msg) {
    return;
  }
  // observations
  rosidl_runtime_c__String__Sequence__fini(&msg->observations);
  // perception_source
  rosidl_runtime_c__String__fini(&msg->perception_source);
  // image
  sensor_msgs__msg__Image__fini(&msg->image);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
}

bool
rai_interfaces__srv__WhatISee_Response__are_equal(const rai_interfaces__srv__WhatISee_Response * lhs, const rai_interfaces__srv__WhatISee_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // observations
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->observations), &(rhs->observations)))
  {
    return false;
  }
  // perception_source
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->perception_source), &(rhs->perception_source)))
  {
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__are_equal(
      &(lhs->image), &(rhs->image)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__WhatISee_Response__copy(
  const rai_interfaces__srv__WhatISee_Response * input,
  rai_interfaces__srv__WhatISee_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // observations
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->observations), &(output->observations)))
  {
    return false;
  }
  // perception_source
  if (!rosidl_runtime_c__String__copy(
      &(input->perception_source), &(output->perception_source)))
  {
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__copy(
      &(input->image), &(output->image)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__WhatISee_Response *
rai_interfaces__srv__WhatISee_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__WhatISee_Response * msg = (rai_interfaces__srv__WhatISee_Response *)allocator.allocate(sizeof(rai_interfaces__srv__WhatISee_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__WhatISee_Response));
  bool success = rai_interfaces__srv__WhatISee_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__WhatISee_Response__destroy(rai_interfaces__srv__WhatISee_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__WhatISee_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__WhatISee_Response__Sequence__init(rai_interfaces__srv__WhatISee_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__WhatISee_Response * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__WhatISee_Response *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__WhatISee_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__WhatISee_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__WhatISee_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__WhatISee_Response__Sequence__fini(rai_interfaces__srv__WhatISee_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__WhatISee_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__WhatISee_Response__Sequence *
rai_interfaces__srv__WhatISee_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__WhatISee_Response__Sequence * array = (rai_interfaces__srv__WhatISee_Response__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__WhatISee_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__WhatISee_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__WhatISee_Response__Sequence__destroy(rai_interfaces__srv__WhatISee_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__WhatISee_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__WhatISee_Response__Sequence__are_equal(const rai_interfaces__srv__WhatISee_Response__Sequence * lhs, const rai_interfaces__srv__WhatISee_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__WhatISee_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__WhatISee_Response__Sequence__copy(
  const rai_interfaces__srv__WhatISee_Response__Sequence * input,
  rai_interfaces__srv__WhatISee_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__WhatISee_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__WhatISee_Response * data =
      (rai_interfaces__srv__WhatISee_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__WhatISee_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__WhatISee_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__WhatISee_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
